#include <stdio.h>

#define CLOSEOK 0
#define BUFFLENGTH 100    /* length of buffer */


makeBIBfile(infile, outfile)
/* read infile, add the <BIB> and </BIB> tags and output to the outfile, */
/* resulting in the form of the outfile being:                           */
/*               <BIB> infile </BIB>                                     */

  char *infile, *outfile;    /* names of input and output files */

{
FILE *fid_in;
FILE *fid_out;
char *buffptr;
char buffer[BUFFLENGTH];
char ch;

  buffptr = buffer;
  if ( !(fid_in = fopen (infile, "r")))
    {
      printf ("Unable to open infile %s for reading\n", infile);
      exit(1);
    }

  if (!(fid_out = fopen (outfile, "w")))
    {
      printf ("Unable to open outfile %s for writing\n", outfile);
      exit(1);
    }

  if (fprintf (fid_out, "%s", "<BIB>") == EOF)
    {
      printf ("Error in writing data to %s \n", outfile);
      exit(1);
    }

  while (fgets(buffptr, BUFFLENGTH, fid_in))
    {
      fputs(buffptr, fid_out);
    }

  ch = ((char) (getc(fid_in)));  /* be sure we are at EOF */
  ungetc(ch, fid_in);
  if  (! feof(fid_in))
    {
      printf ("Error in writing data to %s \n", outfile);
      exit(1);
    }


  if (fprintf (fid_out, "%s", "</BIB>\n") == EOF)
    {
      printf ("Error in writing data to %s \n", outfile);
      exit(1);
    }

  if (fclose(fid_in) != CLOSEOK)
    {
      printf ("Unable to close infile %s\n", infile);
      exit(1);
    }

  if (fclose(fid_out) != CLOSEOK)
    {
      printf ("Unable to close outfile %s\n", outfile);
      exit(1);
    }
}


usage()
/* print usage message to screen */
{
  printf("usage: addbibtag unique_infilename unique_outfilename \n");
  exit(1);
}


main (argc, argv)
     int argc;
     char *argv[];

{
  int  i;           /* loopcounter */

  if (argc == 3)    /* get file names from argv */
    if (strcmp (argv[1], argv[2]) == 0)
      usage();
    else
      {
      makeBIBfile(argv[1], argv[2]);
      }
  else
    usage();
}

