/* CONTENTS
   Owner:       Copyright 1990 The Ohio State University,
                Integrated Chameleon Architecture
   Module:      $RCSfile: aux.c,v $
   Purpose:
       To get auxiliary information from the user.

   Programmer:  Conleth O'Connell
   Reviewer:    
   Revision:    $Revision: 1.3 $
   Date:        $Date: 92/03/18 14:14:48 $

NOTE:
   AVAIL can be:
	HIDDEN for internal use only
	EXPORT for internal and external use

   Functions Index:
   AVAIL   NAME DEPENDS ON INTERNALLY      EXTERNALLY
   -----   ----            ----------      ----------

*/

/* HISTORY
   $Log:	aux.c,v $
 * Revision 1.3  92/03/18  14:14:48  ware
 * Working on consistent interface.
 * 
 * Revision 1.2  1992/01/03  21:53:10  cso
 * Using the message box widgets.
 *
 * Revision 1.1.1.3  1991/10/04  20:15:30  jbm
 * First HaL mods to ICA
 *
 * Revision 2.0  91/03/30  13:46:54  cso
 * This module is now in Alpha Release form.
 * 
 * Revision 1.10  91/02/21  09:52:55  cso
 * Began working on documentation, but because the role of
 * this module may have changed significantly, no documentation was done.
 * 
 * Revision 1.9  90/11/05  17:57:50  cso
 * Added function template to all functions, but still need to fill it in.
 * All cosmetics to get into ICA C style.
 * 
 * 
 * Revision 1.8  90/10/24  15:32:44  cso
 * Changes based on the new types in types.h.
 * 
 * Revision 1.7  90/09/07  09:37:38  cso
 * Cosmetics.
 * 
 * Revision 1.6  90/09/03  18:23:11  cso
 * Function name changes.
 * 
 * Revision 1.5  90/09/03  14:27:56  cso
 * Changed some function names for more consistency.
 * 
 * Revision 1.4  90/08/29  17:45:58  cso
 * removed Alert_Status from being a global variable.
 * 
 * Revision 1.3  90/08/26  14:13:04  cso
 * added module template
 * 
*/

/* NOTE: Only include the header files that are absolutely necessary */
/* #INCLUDES */
#include "aux.h"




/*
   FUNCTION: 		UpdateAux

   Synopsis: 

   Initial purpose:


   Present purpose:


   Creator:	Conleth O'Connell
   Reviewer:	
   Modifications:
       WHO       DATE    REASON

   Interface issues:
      FUNCTION		 PURPOSE

   Operating System issues:
      CALL		 PURPOSE

   Globals used:
	none

   Globals Modified:
	none

   System files modified:
	none

   Return value:	void

   Range:		none
*/

void
UpdateAux(ptr)

Node
   *ptr;

{
   Alt
      *atr;
   Arg
      args[10];

   if (ptr->parent != NULL)
   {
      atr = FindAlt(ptr);
      Auxtree = atr->auxinf;
      XtSetSensitive(XtNameToWidget(Frame, "auxframe*Previous"), False);
      if (Auxtree == NULL)
      {
	 XtSetSensitive(XtNameToWidget(Frame, "auxframe*Done"), False);
	 XtSetSensitive(XtNameToWidget(Frame, "auxframe*Remove"),  False);
	 XtSetSensitive(XtNameToWidget(Frame, "auxframe*Next"), False);
      }
      else
      {
	 XtSetSensitive(XtNameToWidget(Frame, "auxframe*Done"), True);
	 XtSetSensitive(XtNameToWidget(Frame, "auxframe*Remove"),  True);
	 if (Auxtree->next == NULL)
	 {
	    XtSetSensitive(XtNameToWidget(Frame, "auxframe*Next"), False);
	 }
	 else
	 {
	    XtSetSensitive(XtNameToWidget(Frame, "auxframe*Next"), True);
	 }
      }
      XtSetSensitive(XtNameToWidget(Frame, "auxframe*Add"), True);
      if (Auxtree == NULL)
      {
	 XtSetArg(args[0], XtNstring, "");
	 XtSetValues(XtNameToWidget(Frame, "auxframe*value"), args, 1);
	 XtSetSensitive(XtNameToWidget(Frame, "auxframe*value"), False);
      }
      else
      {
	 XtSetArg(args[0], XtNstring, Auxtree->info);
	 XtSetValues(XtNameToWidget(Frame, "auxframe*value"), args, 1);
	 XtSetSensitive(XtNameToWidget(Frame, "auxframe*value"), True);
      }
   }
   else
   {
       XtSetArg(args[0], XtNstring, "");
       XtSetValues(XtNameToWidget(Frame, "auxframe*value"), args, 1);
       XtSetSensitive(XtNameToWidget(Frame, "auxframe*Done"),    False);
       XtSetSensitive(XtNameToWidget(Frame, "auxframe*Remove"),  False);
       XtSetSensitive(XtNameToWidget(Frame, "auxframe*Next"),    False);
       XtSetSensitive(XtNameToWidget(Frame, "auxframe*Add"),     False);
       XtSetSensitive(XtNameToWidget(Frame, "auxframe*Previous"),False);
       XtSetSensitive(XtNameToWidget(Frame, "auxframe*value"),   False);
   }
   return;
}




/*
   FUNCTION: 		GetAuxtype

   Synopsis: 

   Initial purpose:


   Present purpose:


   Creator:	Conleth O'Connell
   Reviewer:	
   Modifications:
       WHO       DATE    REASON

   Interface issues:
      FUNCTION		 PURPOSE

   Operating System issues:
      CALL		 PURPOSE

   Globals used:
	none

   Globals Modified:
	none

   System files modified:
	none

   Return value:	void

   Range:		none
*/

String
GetAuxtype()

{
   /* Generally, a popup needs to be done to let the user choose which
    * kind of auxiliary information should be added.
    */
   return("yacc");
}




/*
   FUNCTION: 		addaux_tree

   Synopsis: 

   Initial purpose:


   Present purpose:


   Creator:	Conleth O'Connell
   Reviewer:	
   Modifications:
       WHO       DATE    REASON

   Interface issues:
      FUNCTION		 PURPOSE

   Operating System issues:
      CALL		 PURPOSE

   Globals used:
	none

   Globals Modified:
	none

   System files modified:
	none

   Return value:	void

   Range:		none
*/

void
addaux_tree(ptr, auxtype)

Node
   *ptr;
String
   auxtype;

{
   Node
      *qtr;
   Alt
      *atr;
   Aux
      *utr;

   for (atr = ptr->alts; atr != NULL; atr = atr->next)
   {
      if (atr->auxinf != Auxtree)
      {
	 utr = NewAux(atr);
	 utr->next = atr->auxinf;
	 atr->auxinf = utr;
	 if (utr->next != NULL)
	 {
	    utr->next->prev = utr;
	 }
	 /* Get a type of information */
	 utr->type = XtNewString(auxtype);
      }
      for (qtr = atr->prod; qtr != NULL; qtr = qtr->next)
      {
	 addaux_tree(qtr, auxtype);
      }
   }
   return;
}




/*
   FUNCTION: 		remaux_tree

   Synopsis: 

   Initial purpose:


   Present purpose:


   Creator:	Conleth O'Connell
   Reviewer:	
   Modifications:
       WHO       DATE    REASON

   Interface issues:
      FUNCTION		 PURPOSE

   Operating System issues:
      CALL		 PURPOSE

   Globals used:
	none

   Globals Modified:
	none

   System files modified:
	none

   Return value:	void

   Range:		none
*/

void
remaux_tree(ptr, auxtype)

Node
   *ptr;
String
   auxtype;

{
   Node
      *qtr;
   Alt
      *atr;
   Aux
      *utr;

   for (atr = ptr->alts; atr != NULL; atr = atr->next)
   {
      utr = atr->auxinf;
      while (utr != NULL)
      {
	 if (strcmp(auxtype, utr->type) == 0)
	 {
	    if (utr == atr->auxinf)
	    {
	       atr->auxinf = utr->next;
	    }
	    else
	    {
	       utr->prev->next = utr->next;
	       if (utr->next != NULL)
	       {
		  utr->next->prev = utr->prev;
	       }
	    }
	    XtFree(utr);
	    utr = NULL;
	 }
	 else
	 {
	    utr = utr->next;
	 }
      }
      for (qtr = atr->prod; qtr != NULL; qtr = qtr->next)
      {
	 remaux_tree(qtr, auxtype);
      }
   }
   return;
}




/*
   FUNCTION: 		auxprev

   Synopsis: 

   Initial purpose:


   Present purpose:


   Creator:	Conleth O'Connell
   Reviewer:	
   Modifications:
       WHO       DATE    REASON

   Interface issues:
      FUNCTION		 PURPOSE

   Operating System issues:
      CALL		 PURPOSE

   Globals used:
	none

   Globals Modified:
	none

   System files modified:
	none

   Return value:	void

   Range:		none
*/

static void
auxprev(w, client_data, call_data)

Widget
   w;
caddr_t
   client_data,
   call_data;

{
   Arg
      args[10];

   if (Auxtree->prev == NULL)
   {
      XtSetSensitive(XtNameToWidget(Frame, "auxframe*Previous"), False);
   }
   else
   {
      Auxtree = Auxtree->prev;
      XtSetArg(args[0], XtNstring, Auxtree->info);
      XtSetValues(XtNameToWidget(Frame, "auxframe*value"), args, 1);
      if (Auxtree->prev == NULL)
      {
	 XtSetSensitive(XtNameToWidget(Frame, "auxframe*Previous"), False);
      }
      else
      {
	 XtSetSensitive(XtNameToWidget(Frame, "auxframe*Previous"), True);
      }
      if (Auxtree->next == NULL)
      {
	 XtSetSensitive(XtNameToWidget(Frame, "auxframe*Next"), False);
      }
      else
      {
	 XtSetSensitive(XtNameToWidget(Frame, "auxframe*Next"), True);
      }
   }
   return;
}




/*
   FUNCTION: 		auxnext

   Synopsis: 

   Initial purpose:


   Present purpose:


   Creator:	Conleth O'Connell
   Reviewer:	
   Modifications:
       WHO       DATE    REASON

   Interface issues:
      FUNCTION		 PURPOSE

   Operating System issues:
      CALL		 PURPOSE

   Globals used:
	none

   Globals Modified:
	none

   System files modified:
	none

   Return value:	void

   Range:		none
*/

static void
auxnext(w, client_data, call_data)

Widget
   w;
caddr_t
   client_data,
   call_data;

{
   Arg
      args[10];

   if (Auxtree->next == NULL)
   {
      XtSetSensitive(XtNameToWidget(Frame, "auxframe*Previous"), False);
   }
   else
   {
      Auxtree = Auxtree->next;
      XtSetArg(args[0], XtNstring, Auxtree->info);
      XtSetValues(XtNameToWidget(Frame, "auxframe*value"), args, 1);
      if (Auxtree->prev == NULL)
      {
	 XtSetSensitive(XtNameToWidget(Frame, "auxframe*Previous"), False);
      }
      else
      {
	 XtSetSensitive(XtNameToWidget(Frame, "auxframe*Previous"), True);
      }
      if (Auxtree->next == NULL)
      {
	 XtSetSensitive(XtNameToWidget(Frame, "auxframe*Next"), False);
      }
      else
      {
	 XtSetSensitive(XtNameToWidget(Frame, "auxframe*Next"), True);
      }
   }
   return;
}




/*
   FUNCTION: 		auxdone

   Synopsis: 

   Initial purpose:


   Present purpose:


   Creator:	Conleth O'Connell
   Reviewer:	
   Modifications:
       WHO       DATE    REASON

   Interface issues:
      FUNCTION		 PURPOSE

   Operating System issues:
      CALL		 PURPOSE

   Globals used:
	none

   Globals Modified:
	none

   System files modified:
	none

   Return value:	void

   Range:		none
*/

static void
auxdone(w, client_data, call_data)

Widget
   w;
caddr_t
   client_data,
   call_data;
{
   Auxtree->info = XtNewString(XawDialogGetValueString
			       (XtNameToWidget(Frame, "auxframe")));
   XtSetSensitive(XtNameToWidget(Frame, "auxframe*Done"), False);
   return;
}




/*
   FUNCTION: 		auxadd

   Synopsis: 

   Initial purpose:


   Present purpose:


   Creator:	Conleth O'Connell
   Reviewer:	
   Modifications:
       WHO       DATE    REASON

   Interface issues:
      FUNCTION		 PURPOSE

   Operating System issues:
      CALL		 PURPOSE

   Globals used:
	none

   Globals Modified:
	none

   System files modified:
	none

   Return value:	void

   Range:		none
*/

static void
auxadd(w, client_data, call_data)

Widget
   w;
caddr_t
   client_data,
   call_data;
{
   Alt
      *atr;

   /* create a new set of AI for this alternative */
   atr = FindAlt(Tree);
   if (atr->auxinf == NULL)
   {
      atr->auxinf = NewAux(atr);
      Auxtree = atr->auxinf;
   }
   else
   {
      Auxtree = NewAux(atr);
      Auxtree->next = atr->auxinf;
      Auxtree->next->prev = Auxtree;
      atr->auxinf = Auxtree;
   }
   /* Get a type of information */
   Auxtree->type = XtNewString(GetAuxtype());
   addaux_tree(Root, Auxtree->type);
   XtSetSensitive(XtNameToWidget(Frame, "auxframe*value"), True);
   XtSetSensitive(XtNameToWidget(Frame, "auxframe*Previous"), False);
   XtSetSensitive(XtNameToWidget(Frame, "auxframe*Done"),   True);
   XtSetSensitive(XtNameToWidget(Frame, "auxframe*Remove"), True);
   if (Auxtree->next == NULL)
   {
      XtSetSensitive(XtNameToWidget(Frame, "auxframe*Next"), False);
   }
   else
   {
      XtSetSensitive(XtNameToWidget(Frame, "auxframe*Next"), True);
   }
}




/*
   FUNCTION: 		auxrem

   Synopsis: 

   Initial purpose:


   Present purpose:


   Creator:	Conleth O'Connell
   Reviewer:	
   Modifications:
       WHO       DATE    REASON

   Interface issues:
      FUNCTION		 PURPOSE

   Operating System issues:
      CALL		 PURPOSE

   Globals used:
	none

   Globals Modified:
	none

   System files modified:
	none

   Return value:	void

   Range:		none
*/

static void
auxrem(w, client_data, call_data)

Widget
   w;
caddr_t
   client_data,
   call_data;
{
   Alt
      *atr;

   if (OkCancelMessage(Frame,
		       "This will remove this information from the grammar"))
   {
      atr = FindAlt(Tree);
      remaux_tree(Root, Auxtree->type);
   }
   return;
}




/*
   FUNCTION: 		CreateAuxShell

   Synopsis: 

   Initial purpose:


   Present purpose:


   Creator:	Conleth O'Connell
   Reviewer:	
   Modifications:
       WHO       DATE    REASON

   Interface issues:
      FUNCTION		 PURPOSE

   Operating System issues:
      CALL		 PURPOSE

   Globals used:
	none

   Globals Modified:
	none

   System files modified:
	none

   Return value:	void

   Range:		none
*/

void
CreateAuxShell(parent, top, left)

Widget
   parent,
   top,
   left;

{
   int
      cnt;
   Arg
      args[10];
   Widget
      auxframe;

   cnt = 0;
   XtSetArg(args[cnt], XtNlabel,    "Auxiliary information"); cnt++;
   XtSetArg(args[cnt], XtNfromVert,  top);                    cnt++;
   XtSetArg(args[cnt], XtNfromHoriz, left);                   cnt++;
   XtSetArg(args[cnt], XtNresizable, True);                   cnt++;
   XtSetArg(args[cnt], XtNvalue,     "");                     cnt++;
   XtSetArg(args[cnt], XtNinput,     True);                   cnt++;
   auxframe = XtCreateManagedWidget("auxframe", dialogWidgetClass,
				    parent, args, cnt);
   XawDialogAddButton(auxframe, "Previous", auxprev, NULL);
   XawDialogAddButton(auxframe, "Next",     auxnext, NULL);
   XawDialogAddButton(auxframe, "Done",     auxdone, NULL);
   XawDialogAddButton(auxframe, "Add",      auxadd,  NULL);
   XawDialogAddButton(auxframe, "Remove",   auxrem,  NULL);
}
