/* CONTENTS
   Owner:       Copyright 1990 The Ohio State University,
                Integrated Chameleon Architecture
   Module:      $RCSfile: helpmenu.c,v $
   Purpose:     Arrange for a text file to be displayed for help.

   Programmer:  Con O'Connell
   Reviewer:    
   Revision:    $Revision: 1.4 $
   Date:        $Date: 92/03/18 14:16:00 $

   Functions Index:
   AVAIL   NAME DEPENDS ON INTERNALLY      EXTERNALLY
   -----   ----            ----------      ----------
   EXPORT  CreateHelpMenu
*/

/* HISTORY
   $Log:	helpmenu.c,v $
 * Revision 1.4  92/03/18  14:16:00  ware
 * Working on consistent interface.
 * 
 * Revision 1.3  1992/01/14  20:13:07  cso
 *  - Reorganizing header files.
 *  - Added the use of the PRINTER environment variable.
 *
 * Revision 1.2  1991/11/20  00:03:46  cso
 * Reorganized the interface by removing borders from around widgets and
 * relocating widgets.
 * Added a status widget to display info that was being output to stderr.
 * The xterm used to instantiate DeveGram is no longer required b/c of
 * this widget.
 * Created a couple of constants for maximum arguments used and width of
 * the interface.
 *
 * Revision 1.1.1.3  1991/10/04  20:16:04  jbm
 * First HaL mods to ICA
 *
 * Revision 2.1  91/05/28  10:05:43  cso
 * Added the use of ICAROOT for finding help files.
 * 
 * Revision 2.0  91/03/30  13:49:08  cso
 * This module is now in Alpha Release form.
 * 
 * Revision 1.5  91/02/22  10:26:50  cso
 * Completed documentation.
 * 
 * Revision 1.4  90/11/20  15:51:40  cso
 * Modified the Help routines to be more like the View shell routines, i.e.,
 * with a manner to print the help screen and as a separate shell.
 * 
 * Revision 1.3  90/11/05  18:18:49  cso
 * Added function template to all functions, but still need to fill it in.
 * Else, cosmetics.
 * 
 * Revision 1.2  90/10/29  10:23:24  cso
 * Added the appropriate decls to make it work.
 * 
 * Revision 1.1  90/10/25  13:34:57  cso
 * Initial revision
 * 
*/

/* #INCLUDES */

#include "std.h"
#include "widgets.h"
#include "types.h"
#include "defs.h"

#include "main.h"
#include "Xica/help.h"



/*
   FUNCTION: 		CreateHelpMenu

   Synopsis: 
       Create the menu offering the help options.

   Initial purpose:
       Same as above.

   Present purpose:
       Same as above.


   Creator:	Conleth O'Connell
   Reviewer:	

   Modifications:
       DATE       WHO    REASON
       91-05-23   cso    Added the use of ICAROOT.
       6 Mar 92	  pete	 Gutted and moved guts to Xica.

   Globals used:
       none

   Globals Modified:
       none

   Return value:	void

   Range:		none
*/

void
CreateHelpMenu(parent)
Widget	parent;      /* The parent of the list of help options */
{
   Arg		args[MAXARGS];/* List of arguments */
   int		cnt;      /* Number of arguments */
   String	filename;
   
   Widget	help1sel; /* Help selection 1 */

   cnt = 0;
   XtSetArg(args[cnt], XtNlabel,    "Introduction"); cnt++;
   help1sel = XtCreateManagedWidget ("help1sel", smeBSBObjectClass,
				    parent, args, cnt);
   filename = XtNewString ("DeveGram.hlp");
   XtAddCallback(help1sel, XtNcallback, XicaHelp, filename);
   return;
}
