/*
  $Log:	main.h,v $
 * Revision 1.5  92/03/18  14:16:25  ware
 * Working on consistent interface.
 * 
 * Revision 1.4  1992/01/14  14:33:50  cso
 * Changed the organization of the header files and dependencies.  I was
 * brain-damaged when I first did this |-)
 *
 * Revision 1.3  1991/11/25  14:37:05  cso
 * Made lint modifications to ensure that function and variable types are
 * being used and declared correctly and consistently.
 *
 * Revision 1.2  1991/11/20  00:04:20  cso
 * Reorganized the interface by removing borders from around widgets and
 * relocating widgets.
 * Added a status widget to display info that was being output to stderr.
 * The xterm used to instantiate DeveGram is no longer required b/c of
 * this widget.
 * Created a couple of constants for maximum arguments used and width of
 * the interface.
 *
 * Revision 1.1.1.3  1991/10/04  20:16:16  jbm
 * First HaL mods to ICA
 *
 * Revision 2.1  91/05/28  10:22:35  cso
 * Removed Chosen_Symbol.
 * 
 * Revision 2.0  91/03/30  13:50:23  cso
 * This module is now in Alpha Release form.
 * 
 * Revision 1.11  91/03/28  14:53:47  cso
 * Added the global Threed.
 * 
 * Revision 1.10  91/02/22  10:14:11  cso
 * Documented globals and added other explanations.
 * 
 * Revision 1.9  90/11/20  16:10:38  cso
 * Cosmetic changes to make it easier to see the types (mostly externs).
 * Also, changes because of lint (functions with undeclared types).
 * This actually elimianted some errors.
 * 
 * Revision 1.8  90/11/05  18:37:50  cso
 * Removed Terminal_Cnt, OpenFile.  Added InstallSignalHandlers.
 * 
 * Revision 1.7  90/10/24  15:53:50  cso
 * Changes were based on the new types in types.h.
 * 
 * Revision 1.6  90/09/03  18:33:12  cso
 * Added extern decl for WIpeWindow().
 * 
 * Revision 1.5  90/09/03  14:53:51  cso
 * Changed function names to be consistent.
 * 
 * Revision 1.4  90/08/29  17:56:57  cso
 * Removed Alert_Status and global file stuff.
 * 
 * Revision 1.3  90/08/26  17:46:23  cso
 * Added the RCS Log message at the top for these messages.
 * 
*/



/* extern variables */

extern Boolean
   Dirtyflag;             /* Indicates a change in the grammar */
extern GrammarData
   Info[];       /* Symbol table */
extern int
   Defndx,                 /* Index into the available symbols list.
			      It always points to the next 
			      available position for a symbol, thus
			      it always indicates the number of elements. */
   Ndx,                    /* Index into the symbol table.
			      It always points to the next 
			      available position for a symbol, thus
			      it always indicates the number of elements. */
   Pathndx,                /* Index into the stack of elements implementing
			      the path mechanism of navigation
			      (currently unused).
			      It always points to the next 
			      available position for a node, thus
			      it always indicates the number of elements. */
   Undndx;                 /* Index into the undefined symbols list.
			      It always points to the next 
			      available position for a symbol, thus
			      it always indicates the number of elements. */
extern Node
   *Chosennode,           /* The node selected by the user. */
   *Pathlist[],   /* The stack for the path navigation mechanism */
   *Root,                  /* This pointer ALWAYS points at the root node in 
			      the node data structure. */ 
   *Tree;                  /* This pointer traverses the tree, and follows the
			      focus of the user.*/
extern Pixmap
  Threed;		   /* The background pixmap used to show
			      that a symbol has more than one definition */
extern String
   Defsymlist[], /* The available symbols list */
   Undsymlist[]; /* The undefined symbols list */
extern Widget
   Frame,                  /* The form widget containing the main interface */
   Toplevel;               /* The shell widget associated with the 
			      application context. */
extern XtAppContext
   Appcon;                /* The application context for this environment */

/* External routines */

extern void
   Initialize();
