/* CONTENTS
   Owner:       Copyright 1991 The Ohio State University,
                Integrated Chameleon Architecture
   Module:      $RCSfile: status.c,v $
   Purpose:     To feedback status information to the user.

   Programmer:  Conleth O'Connell
   Reviewer:    
   Revision:    $Revision: 1.5 $
   Date:        $Date: 92/05/29 14:46:30 $


   Functions Index:
   AVAIL   NAME DEPENDS ON INTERNALLY      EXTERNALLY
   -----   ----            ----------      ----------

*/

/* HISTORY
   $Log:	status.c,v $
 * Revision 1.5  92/05/29  14:46:30  boyd
 * Changes for improved resizing, consisting mostly of replacing Form widgets
 * with Group, Table, and Viewform widgets.
 * 
 * 
 * Revision 1.4  92/03/18  14:17:21  ware
 * Working on consistent interface.
 * 
 * Revision 1.3  1992/01/14  17:57:29  cso
 *  - Reorganizing header files.
 *
 * Revision 1.2  1991/11/22  15:35:24  cso
 * 	Added a graphics context to the node type for easier
 * manipualtion of the line drawing in the navigation tree.  Tried to
 * eliminate the number of refreshes occurring for a particular expose
 * event, tough to debug in synchronous mode.
 *
 * Revision 1.1  1991/11/20  00:01:32  cso
 * Initial revision
 *
*/

/* #INCLUDES */

#include "widgets.h"
#include "defs.h"

/* #DEFINES  */

/*  EXTERNS  */

/*  GLOBALS  */

Widget
   Statw;



/*
   FUNCTION: 		CreateStatus

   Synopsis: 
       Create the window for feeding back status info.

   Initial purpose:
       Same as above.

   Present purpose:
       Same as above.

   Creator:	Conleth O'Connell
   Reviewer:	

   Modifications:
       DATE     WHO      REASON

   Operating System issues:
       CALL		 PURPOSE

   System files modified:
       none

   Globals used:
       none

   Globals Modified:
       none

   Return value:	Widget

   Range:		none
*/

Widget CreateStatus( parent )
Widget parent;
{
   Widget statframe, statlabel;
      
   statframe = XtVaCreateManagedWidget( "statframe",
       groupWidgetClass, parent,
       XtNspacing,   0,
       XtNalignment, gaFill,
/*
       XtNstretch,   False,
*/
       XtNmargin,    8,
       NULL );

   statlabel = XtVaCreateManagedWidget( "statlabel",
       labelWidgetClass, statframe,
       XtNlabel,       "Status:",
       XtNborderWidth, 0,
       XtNmargin,      0,
       NULL );

   Statw = XtVaCreateManagedWidget( "Statw",
       statusWidgetClass, statframe,
       XtNalignment,        gaFill,
       XtNpreference,       False,
/*
       XtNprefHeight,       96,
       XtNminHeight,        20,
       XtNstretch,          False,
*/
       XtNmargin,           0,
       NULL );

   return(statframe);
}
