/*
   Owner:       Copyright 1992 The Ohio State University,
                Integrated Chameleon Architecture
   Module:      $RCSfile: loadtoken.l,v $
   Purpose:     

   Programmer:  Conleth O'Connell
   Reviewer:    
   Revision:    $Revision: 1.1 $
   Date:        $Date: 92/05/21 22:40:19 $

   HISTORY
   $Log:	loadtoken.l,v $
 * Revision 1.1  92/05/21  22:40:19  ware
 * Removed many files that are derived from other files.
 * 
# Revision 1.4  92/03/16  12:20:07  ware
# Merging cso and OSU versions.  Changes for titles.
# 
# Revision 1.3  1992/03/10  20:15:44  cso
# Changed the language of the spec file to load and save specs
#
# Revision 1.2  1992/02/28  14:51:10  cso
# The latest incarnations recognizing and installing the mapping
# information at the top of the g2s file.
#
# Revision 1.1  1992/02/06  05:33:21  cso
# Initial revision
#
# Revision 1.3  1992/01/14  20:54:51  cso
# Connected up the code generation with the interface.
#
# Revision 1.2  1992/01/10  02:24:58  cso
# Visual code inspection changes, and the first steps of integrating the
# functionality of the up translator generator.
#

*/

%{
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include <Xica/Status.h>

#include "types.h"
#include "load.h"

extern Boolean Passflag;
extern char *makestr();
extern Widget Statw;

int linecount;
%}

%START TAGINFO JUNKINFO POS NESTING EDITNEST1 EDITNEST2
%%

<TAGINFO>^"$$$$\n"	{
			   BEGIN 0;
			   linecount++;
			   return(TOKENSEPARATOR);
}

<TAGINFO>"\\\\\\\\\n"	{
			   BEGIN EDITNEST1;
			   linecount++;
			   return(CTXTBEG);
}

<EDITNEST2>"////\n"	{
			   BEGIN TAGINFO;
			   linecount++;
			   return(CTXTEND);
}

<EDITNEST2,TAGINFO>[ 0-9a-zA-Z!@#$%^&*()_+|\-=\\\[\]{};'`:"~,\.\/<>?]+	{
			   yylval.symbol.str = makestr(yytext);
			   return(MAPPING);
}

^"$$$$\n"			{
			   BEGIN 0;
			   BEGIN TAGINFO;
			   linecount++;
			   return(TOKENSEPARATOR);
}

<NESTING>":DATA:"	{
}

<NESTING,EDITNEST1>":IN:"		{
			   return(IN);
}

<EDITNEST1>":IN:"	{
			   return(IN);
}

<NESTING>":MIXED:"	{
}

<NESTING>":NULL:"	{
}

<NESTING>":TAGS:"	{
}

<NESTING>":TOPLEVEL:"	{
}

<TAGINFO>[\n]		{
			   linecount++;
			   return(LINEFEED);
}

<EDITNEST2,NESTING>[\n]	{
			   linecount++;
			   return(LINEFEED);
}

<EDITNEST1>[\n]	{
			   BEGIN EDITNEST2;
			   linecount++;
			   return(LINEFEED);
}

<JUNKINFO>"#### Insert Tag Tool Rules ####\n" {
			   BEGIN NESTING;
			   linecount++;
}

<JUNKINFO>(.)+		{
}

<JUNKINFO>\n		{
			   linecount++;
}

^"####"			{
   /* Should we ever need to look at the retagging or insert tagging
	info from the ICA file */
			   BEGIN JUNKINFO;
}



<POS>"]"		{
			   BEGIN 0;
			   return(POS_CLOSE);
}

<POS>[0-9]+		{
			   int
			      i,
			      number;

			   number = 0;
			   for (i = 0; i < strlen(yytext); i++)
			   {
			      number = (10 * number) + (yytext[i] - '0');
			   }   
			   yylval.symbol.pos = number;
			   return(POSITION);
}


\<","?[a-zA-Z0-9_\-\.]+\>	{
                           yylval.symbol.str = makestr(yytext);
			   return(STARTTAG);
}

\<\/[a-zA-Z0-9_\-\.]+\>	{
                           yylval.symbol.str = makestr(yytext);
			   return(ENDTAG);
}

[a-zA-Z0-9_\-\.]+	{
                           yylval.symbol.str = makestr(yytext);
			   return(SYMBOL);
}

"*"			{
                           yylval.symbol.occur = makestr(yytext);
			   return(OCCURRENCE);
}

"+"			{
                           yylval.symbol.occur = makestr(yytext);
			   return(OCCURRENCE);
}

"?"			{
                           yylval.symbol.occur = makestr(yytext);
			   return(OCCURRENCE);
}

":"			{
   			   return(SEPARATOR);
}

"("			{
			   return(AR_OPEN);
}

")"			{
			   return(AR_CLOSE);
}

"#["			{
			   BEGIN POS;
			   return(POS_OPEN);
}

";"			{
			   return(SEMICOLON);
}

"|"			{
			   return(OR);
}

[\n]			{
			   linecount++;
}

[ \t]			{
}

%%

void
yyerror(errorstr)

char
   *errorstr;

{
   XicaStatus(Statw, "Error [%s] at or before [%s] on line [%5d]\n",
              errorstr, yytext, linecount);
   return;
}

#undef yywrap()

int
yywrap()
{
   return (1);
}

