/*
   Owner:       Copyright 1992 The Ohio State University,
                Integrated Chameleon Architecture
   Module:      $RCSfile: output.h,v $
   Purpose:     

   Programmer:  Conleth O'Connell
   Reviewer:    
   Revision:    $Revision: 1.4 $
   Date:        $Date: 92/03/16 12:20:45 $

   HISTORY
   $Log:	output.h,v $
 * Revision 1.4  92/03/16  12:20:45  ware
 * Merging cso and OSU versions.  Changes for titles.
 * 
 * Revision 1.3  1992/03/10  22:04:24  cso
 * Modified the standard output stuff to reference the ICA stack and push
 * and pop routines.  Also, modified the character alphabet to not
 * include &.
 *
 * Revision 1.2  1992/02/21  23:02:42  cso
 * Removed spec2gen related routines
 *
 * Revision 1.1  1992/02/06  05:34:33  cso
 * Initial revision
 *
 * Revision 1.1  1992/01/10  02:24:01  cso
 * Initial revision
 *


*/

/* #INCLUDES */

/* #DEFINES  */

/*  EXTERNS  */

/*  GLOBALS  */

char
   *yacchead[] = 
{
   "%{",
   "#include <stdio.h>",
   "#include <ctype.h>",
   "#include <icatypes.h>",
   "",
   "extern int Top;",
   "extern int ICA_stack[];",
   "%}",
   "",
   "%union",
   "{",
   " char         *data;",
   " int           ival;",
   " int           sepflag;",
   " ConcatStruct *trans;",
   "}",
   "",
   0
};


char
   *lexhead[] =
{
   "/*   Lex description of nonuniform tag set.   */",
   "/*                                            */",
   "/* Copyright 1990. The Ohio State University. */",
   "/*                                            */",
   "",
   "%a 30000",
   "%e 10000",
   "%k 10000",
   "%n 10000",
   "%o 40000",
   "%p 20000",
   "",
   "%{",
   "#include <icatypes.h>",
   "#include \"y.tab.h\"",
   "",
   "extern void pop();",
   "extern void push();",
   "",
   "int linecount = 1;",
   "%}",
   "",
   "%START WSPACE",
   "",
   "%%",
   "[a-zA-Z0-9\\-_!@#$%^*()=+|\\\\~`'\",.;:\\[\\]{}?/]+\t{",
   "\t BEGIN 0;",
   "\t BEGIN WSPACE;",
   "\t yylval.data = makestr(yytext);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",
   "[<>&]\t{",
   "\t BEGIN 0;",
   "\t BEGIN WSPACE;",
   "\t yylval.data = makestr(yytext);",
   "\t fprintf(stderr, \"WARNING: [%s] on line [%d] should be a symbol\\n\",",
   "\t         yytext, linecount);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",   
   "<WSPACE>[ \\t]+\t{",
   "\t yylval.data = makestr(yytext);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",   
   "<WSPACE>[\\n]\t{",
   "\t linecount++;",
   "\t yylval.data = makestr(yytext);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",   
   "[ \\t]+\t{",
   "\t}",
   "",   
   "[\\n]\t{",
   "\t linecount++;",
   "\t}",
   "",   
   0
};

char
   *lextail[] =
{
   "\"&\"[0-9a-zA-Z_.]+\";\"\t{",
   "\t BEGIN 0;",
   "\t BEGIN WSPACE;",
   "\t yylval.data = makestr(yytext);",
   "\t fprintf(stderr, \"Unrecognized entity [%s] on line [%d]\\n\",",
   "\t         yytext, linecount);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",
   "\"<\"[/]?[0-9a-zA-Z_.]+\">\"\t{",
   "\t BEGIN 0;",
   "\t BEGIN WSPACE;",
   "\t yylval.data = makestr(yytext);",
   "\t fprintf(stderr, \"Unrecognized tag [%s] on line [%d]\\n\",",
   "\t         yytext, linecount);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",
   ".\t{",
   "\t yylval.data = makestr(yytext);",
   "\t fprintf(stderr, \"Unrecognized character [%#5x] on line [%d]\\n\",",
   "\t         yytext[0], linecount);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",
   0
};
