/* CONTENTS */
/* Owner:       Copyright 1990 The Ohio State University, */
/*              Integrated Chameleon Architecture */
/* Module:      $RCSfile: rsftoken.l,v $ */
/* Purpose:     Contains all of the token patterns for a .rsf specification. */
/* Programmer:  Julie Barnes */
/* Reviewer:     */
/* Revision:    $Revision: 1.1 $ */
/* Date:        $Date: 92/05/21 22:40:30 $ */

/* HISTORY */
/*Revision 1.1  90/10/05  13:18:58  cso */
/*Initial revision */

/* Lex specification for the retag specification language */
/* compiler.                                              */
/*                                                        */
/* Copyright 1990. The Ohio State University.             */

%a 10000
%o 15000

%{
#include "rsfparse.h"

extern char *makestr();

int
   linecount;

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include <Xica/Status.h>

extern Widget Statw;
%}


%%
"DATA ALPHABET:"|"TEXT ALPHABET:"	{
	 return(DATACHAR);
	}

"TAG ALPHABET:"|"RESERVED CHARACTERS:"	{
	 return(TAGCHAR);
	}

"AMBIGUOUS ALPHABET:"|"SPECIAL CHARACTERS:"	{
	 return(AMBIGCHAR);
	}

"SPECIAL SYMBOLS:\n"	{
	 linecount++;
	 return(SYMBOL);
	}

"PROCESSING INSTRUCTIONS:\n"|"NONSYMBOLS:\n"		{
	 linecount++;
	 return(PROCIN);
	}

"IMPLICIT TAGS:\n"|"SEGMENTING TAGS:\n"	{
	 linecount++;
	 return(IMPTAG);
	}

"EXPLICIT TAGS:\n"	{
	 linecount++;
	 return(EXPTAG);
	}

"DELIMITING TAGS:\n"	{
	 linecount++;
	 return(DELTAG);
	}

"SEPARATOR TAGS:\n"	{
	 linecount++;
	 return(SEPTAG);
	}

"\t:START:"[ ]?	{
	 return(START);
	}

"\t:END:"[ ]?	{
	 return(END);
	}

"\t:IN:"[ ]?	{
	 return(IN);
	}

"\t:NEST:"[ ]?	{
	 return(NEST);
	}

"\t:DEFINES:"[ ]?	{
	 return(DEFINE);
	}

\n	{
	 linecount++;
	 return(LINEFEED);
	}

\t	{
	}

[ a-zA-Z0-9!@#$%\^&*()\-_=+\\|\[\]{};:'"`~,.<>/?]+	{
#ifdef DEBUG
	 fprintf(stderr, "RCOMP.LEX: STRING [%s]\n", yytext); 
#endif
	 yylval.trans = (char *) makestr(yytext);
	 return(STRING);
	}

%%

void
yyerror(errorstr)

char
   *errorstr;

{
   XicaStatus(Statw, "Error [%s] at or before [%s] on line [%5d]\n",
	      errorstr, yytext, linecount);
   return;
}

#undef yywrap()

int
yywrap()
{
   return(1);
}

