/* CONTENTS
   Owner:       Copyright 1990 The Ohio State University,
                Integrated Chameleon Architecture
   Module:      
   Purpose:     To load a user file which conforms to frank's grammer.
   Programmer:  Conleth O'Connell
   Reviewer:    
   Revision:    $Revision: 1.4 $
   Date:        $Date: 92/03/16 13:02:38 $
*/

/* HISTORY
   $Log:	load.y,v $
 * Revision 1.4  92/03/16  13:02:38  ware
 * Conditionalize the title
 * 
 * Revision 1.3  1992/01/14  20:54:59  cso
 * Connected up the code generation with the interface.
 *
 * Revision 1.2  1992/01/10  02:25:02  cso
 * Visual code inspection changes, and the first steps of integrating the
 * functionality of the up translator generator.
 *
 * Revision 1.1  1992/01/08  19:55:12  cso
 * Initial revision
 *
*/


%{
#include <stdio.h>
#include <X11/Intrinsic.h>
#include "types.h"

#include "initialize.h"
#include "main.h"

int
   Poscnt;
%}

%union
{
   struct 
   {
      String
	 str;
      String
	 occur;
      int
	 pos;
   } symbol;

   RhsList
     *rhsptr;
   PermutationList
     *permptr;
}

%token <symbol>
AR_CLOSE
AR_OPEN
ENDTAG
OCCURRENCE
POS_OPEN
POSITION
POS_CLOSE
OR
SEMICOLON
SEPARATOR
STARTTAG
SYMBOL

%type <symbol>
lhs
occurOPTL
posOPTL
symbol

%type <rhsptr>
rhs_list
mapping
rhs

%type <permptr>
action_routine
ar_list
ar_sym_list
ar_sym_listOPTL

%start Spec2Gen

%%
Spec2Gen	: productionPLUS
		{
		}	
		;

productionPLUS	: productionPLUS production
		{
		}
		| production
		{
		}
		;

production	: lhs SEPARATOR rhs_list SEMICOLON
		{
		   int
		      i;
		   RhsList
		      *rl;
		   
		   Grammar[Gmax].lhs       = XtNewString($1.str);
		   Grammar[Gmax].rhs       = $3;
		   Grammar[Gmax].activerhs = $3;
		   for (i = 0, rl = Grammar[Gmax].rhs; rl != NULL; 
			i++, rl = rl->next)
		   {
		   }
		   Grammar[Gmax].numrhs    = i;
		   Gmax++;
		   XtFree($1.str);
		}
		;

lhs		: SYMBOL
		{
		   $$.str   = $1.str;
		   $$.occur = XtNewString("");
		   $$.pos   = 0;
		}
		;

rhs_list	: mapping 
		{
		   $$ = $1;
		}
		| rhs_list OR mapping 
		{
		   RhsList
		      *rptr;
		   
                   rptr = $1;
		   if (rptr != NULL)
		   {
		      for ( ; rptr->next != NULL; rptr = rptr->next)
		      {
		      }
		      rptr->next = $3;
		      if ($3 != NULL)
		      {
			 $3->prev = rptr;
		      }
		      $$ = $1;
		   }
		   else 
		   {
		      fprintf(stderr, "rhslist: $1->symbol is NULL\n");
		      exit(1);
		   }
		}
		;

mapping		: rhs ar_list 
		{
		   $1->perminstance = $2;
		   $1->activeperm   = $2;
		   $$               = $1;
		}
		;

rhs		: symbol
		{
		   RhsList
		      *rptr;
		   
		   Poscnt                  = 1;

		   rptr                    = XtNew(RhsList);
		   rptr->next              = NULL;
		   rptr->prev              = NULL;
		   rptr->perminstance      = NULL;
		   rptr->symbol            = XtNew(SymbolList);
		   rptr->symbol->prev      = NULL;
		   rptr->symbol->next      = NULL;
		   rptr->symbol->symbutton = NULL;
		   rptr->symbol->symbolstr = XtNewString($1.str);
		   rptr->symbol->occurstr  = XtNewString($1.occur);
		   if ($1.pos == 0)
		   {
		      rptr->symbol->position = Poscnt;
		   }
		   else
		   {
		      rptr->symbol->position = $1.pos;
		   }
		   $$                      = rptr;
		   Poscnt++;
		   XtFree($1.str);
		   XtFree($1.occur);
		}
		| rhs symbol 
		{
		   SymbolList
		      *sptr;
		   
		   sptr = $1->symbol;
		   if (sptr != NULL)
		   {
		      for ( ; sptr->next != NULL; sptr = sptr->next)
		      {
		      }
		      sptr->next            = XtNew(SymbolList);
		      sptr->next->prev      = sptr;
		      sptr->next->next      = NULL;
		      sptr->next->symbutton = NULL;
		      sptr->next->symbolstr = XtNewString($2.str);
		      sptr->next->occurstr  = XtNewString($2.occur);
		      if ($2.pos == 0)
		      {
			 sptr->next->position = Poscnt;
		      }
		      else
		      {
			 sptr->next->position = $2.pos;
		      }
		      $$                    = $1;
		      Poscnt++;
		   }
		   else 
		   {
		      fprintf(stderr,
			      "rhs: $1->symbol is NULL\n");
		      exit(1);
		   }
		   XtFree($2.str);
		   XtFree($2.occur);
		}
		;

symbol		: STARTTAG posOPTL
		{
		   $$.str   = $1.str;
		   $$.occur = XtNewString("");
		   $$.pos   = $2.pos;
		}
                | ENDTAG posOPTL
		{
		   $$.str   = $1.str;
		   $$.occur = XtNewString("");
		   $$.pos   = $2.pos;
		}
		| SYMBOL occurOPTL posOPTL
		{
		   if ((strcmp($1.str, "CDATASTAR") == 0) ||
		       (strcmp($1.str, "CDATAPLUS") == 0))
		   {
		      XtFree($1.str);
		      $$.str = XtNewString("ICA_Char_DATASTAR");
		      Dirtyflag = True;
		      
		   }
		   else
		   {
		      $$.str   = $1.str;
		   }
		   
		   $$.occur = $2.occur;
		   $$.pos   = $3.pos;
		}
		;

occurOPTL	: OCCURRENCE
		{
		   $$.occur = $1.occur;
		}
		| /* Exactly once */
		{
		   $$.occur = XtNewString("");
		}
		;
    
posOPTL		: POS_OPEN POSITION POS_CLOSE
		{
		   $$.pos = $2.pos;
		}
		| /* Exactly once */
		{
		   $$.pos = 0;
		}
		;
    
ar_list		: action_routine
		{
		   $$ = $1;
		}
		| ar_list action_routine 
		{
		   PermutationList
		      *pptr;
		   
		   if ($1 != NULL)
		   {
		      for (pptr = $1; pptr->next != NULL;
			   pptr = pptr->next)
		      {
		      }
		      pptr->next = $2;
		      if ($2 != NULL)
		      {
			 $2->prev = pptr;
		      }
		      $$ = $1;
		   }
		}
		;

action_routine	: AR_OPEN ar_sym_listOPTL AR_CLOSE 
		{
		   $$ = $2;
		}
		;

ar_sym_listOPTL	: ar_sym_list
		{
		   $$ = $1;
		}
		| /* Empty action routine */
		{
		   /*
		    * In the first cut at this tool,
		    * an empty action routine meant the default
		    * ordering, so to maintain backward compatibility
		    * copy the current rhs.
		    * This will have to work on the other side, after
		    * loading the data structures because of the
		    * inherited attributes in yacc
		    */
		   PermutationList
		      *pptr;

		   pptr             = XtNew(PermutationList);
		   pptr->next       = NULL;
		   pptr->prev       = NULL;
		   pptr->permsymbol = NULL;
		   $$               = pptr;
		}
		;

ar_sym_list	: symbol
		{
		   PermutationList
		      *pptr;

		   Poscnt                      = 1;

		   pptr                        = XtNew(PermutationList);
		   pptr->next                  = NULL;
		   pptr->prev                  = NULL;
		   pptr->permsymbol            = XtNew(SymbolList);
		   pptr->permsymbol->prev      = NULL;
		   pptr->permsymbol->next      = NULL;
		   pptr->permsymbol->symbutton = NULL;
		   pptr->permsymbol->symbolstr = XtNewString($1.str);
		   pptr->permsymbol->occurstr  = XtNewString($1.occur);
		   if ($1.pos == 0)
		   {
		      pptr->permsymbol->position = Poscnt;
		   }
		   else
		   {
		      pptr->permsymbol->position = $1.pos;
		   }
		   $$                          = pptr;
		   Poscnt++;
		   XtFree($1.str);
		   XtFree($1.occur);
		}
		| ar_sym_list symbol
		{
		   SymbolList
		      *sptr;
		   
		   sptr = $1->permsymbol;
		   if (sptr != NULL)
		   {
		      for ( ; sptr->next != NULL; sptr = sptr->next)
		      {
		      }
		      sptr->next            = XtNew(SymbolList);
		      sptr->next->prev      = sptr;
		      sptr->next->next      = NULL;
		      sptr->next->symbutton = NULL;
		      sptr->next->symbolstr = XtNewString($2.str);
		      sptr->next->occurstr  = XtNewString($2.occur);
		      if ($2.pos == 0)
		      {
			 sptr->next->position = Poscnt;
		      }
		      else
		      {
			 sptr->next->position = $2.pos;
		      }
		      Poscnt++;
		   }
		   $$ = $1;
		   XtFree($2.str);
		   XtFree($2.occur);
		}
		;

%%

