/*
   Owner:       Copyright 1992 The Ohio State University,
                Integrated Chameleon Architecture
   Module:      $RCSfile: loadtoken.l,v $
   Purpose:     

   Programmer:  Conleth O'Connell
   Reviewer:    
   Revision:    $Revision: 1.1 $
   Date:        $Date: 92/05/21 22:40:49 $

   HISTORY
   $Log:	loadtoken.l,v $
 * Revision 1.1  92/05/21  22:40:49  ware
 * Removed many files that are derived from other files.
 * 
# Revision 1.4  92/03/16  13:02:35  ware
# Conditionalize the title
# 
# Revision 1.3  1992/01/14  20:54:51  cso
# Connected up the code generation with the interface.
#
# Revision 1.2  1992/01/10  02:24:58  cso
# Visual code inspection changes, and the first steps of integrating the
# functionality of the up translator generator.
#

*/

%{
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include <Xica/Status.h>

#include "types.h"
#include "load.h"

extern char *makestr();
extern Widget Statw;

int linecount;
%}

%START TAGINFO JUNKINFO POS
%%

<TAGINFO>^"$$$$"	{
			   BEGIN 0;
}

<TAGINFO>[ 0-9a-zA-Z!@#$%^&*()_+|\-=\\\[\]{};'`:"~,\.\/<>?]+	{
}

^"$$$$"			{
			   BEGIN TAGINFO;
}

^"####"			{
   /* Should we ever need to look at the retagging or insert tagging
	info from the ICA file */
			   BEGIN JUNKINFO;
}

<JUNKINFO>(.)+		{
}

<JUNKINFO>\n		{
			   linecount++;
}

<POS>"]"		{
			   BEGIN 0;
			   return(POS_CLOSE);
}

<POS>[0-9]+		{
			   int
			      i,
			      number;

			   number = 0;
			   for (i = 0; i < strlen(yytext); i++)
			   {
			      number = (10 * number) + (yytext[i] - '0');
			   }   
			   yylval.symbol.pos = number;
			   return(POSITION);
}


\<[a-zA-Z0-9_\-\.]+\>	{
                           yylval.symbol.str = makestr(yytext);
			   return(STARTTAG);
}

\<\/[a-zA-Z0-9_\-\.]+\>	{
                           yylval.symbol.str = makestr(yytext);
			   return(ENDTAG);
}

[a-zA-Z0-9_\-\.]+	{
                           yylval.symbol.str = makestr(yytext);
			   return(SYMBOL);
}

"*"			{
                           yylval.symbol.occur = makestr(yytext);
			   return(OCCURRENCE);
}

"+"			{
                           yylval.symbol.occur = makestr(yytext);
			   return(OCCURRENCE);
}

"?"			{
                           yylval.symbol.occur = makestr(yytext);
			   return(OCCURRENCE);
}

":"			{
   			   return(SEPARATOR);
}

"("			{
			   return(AR_OPEN);
}

")"			{
			   return(AR_CLOSE);
}

"#["			{
			   BEGIN POS;
			   return(POS_OPEN);
}

";"			{
			   return(SEMICOLON);
}

"|"			{
			   return(OR);
}

[\n]			{
			   linecount++;
}

[ \t]			{
}

%%

void
yyerror(errorstr)

char
   *errorstr;

{
   XicaStatus(Statw, "Error [%s] at or before [%s] on line [%5d]\n",
              errorstr, yytext, linecount);
   return;
}

#undef yywrap()

int
yywrap()
{
   return (1);
}

