/*
   Owner:       Copyright 1992 The Ohio State University,
                Integrated Chameleon Architecture
   Module:      $RCSfile: output.h,v $
   Purpose:     

   Programmer:  Conleth O'Connell
   Reviewer:    
   Revision:    $Revision: 1.5 $
   Date:        $Date: 92/05/20 11:50:19 $

   HISTORY
   $Log:	output.h,v $
 * Revision 1.5  92/05/20  11:50:19  ware
 * Added & as character
 * 
 * Revision 1.4  92/03/16  13:03:02  ware
 * Conditionalize the title
 * 
 * Revision 1.3  1992/03/10  18:23:56  cso
 * Removed unnecessary decls
 *
 * Revision 1.2  1992/02/06  06:14:16  cso
 * Removed unnecessary escapes (\%)
 *
 * Revision 1.1  1992/01/10  02:24:01  cso
 * Initial revision
 *


*/

/* #INCLUDES */

/* #DEFINES  */

/*  EXTERNS  */

/*  GLOBALS  */

char
   *yacchead[] = 
{
   "%{",
   "#include <stdio.h>",
   "#include <ctype.h>",
   "#include <icatypes.h>",
   "",
   "%}",
   "",
   "%union",
   "{",
   " int   ival;",
   " char *data;",
   " ConcatStruct *trans;",
   "}",
   "",
   0
};


char
   *lexhead[] =
{
   "/*   Lex description of nonuniform tag set.   */",
   "/*                                            */",
   "/* Copyright 1990. The Ohio State University. */",
   "/*                                            */",
   "",
   "%a 30000",
   "%e 10000",
   "%k 10000",
   "%n 10000",
   "%o 40000",
   "%p 20000",
   "",
   "%{",
   "#include <icatypes.h>",
   "#include \"y.tab.h\"",
   "",
   "#ifndef NOINTERFACE",
   "extern void UpdateHighlight();",
   "#endif",
   "",
   "int linecount = 1;",
   "%}",
   "",
   "%START WSPACE",
   "",
   "%%",
   "[a-zA-Z0-9\\-_!@#$%^&*()=+|\\\\~`'\",.;:\\[\\]{}?/]+\t{",
   "\t BEGIN 0;",
   "\t BEGIN WSPACE;",
   "\t yylval.data = makestr(yytext);",
   "#ifndef NOINTERFACE",
   "\t UpdateHighlight(yyleng);",
   "#endif",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",
   "[<>]\t{",
   "\t BEGIN 0;",
   "\t BEGIN WSPACE;",
   "\t yylval.data = makestr(yytext);",
   "#ifndef NOINTERFACE",
   "\t UpdateHighlight(yyleng);",
   "#endif",
   "\t fprintf(stderr, \"WARNING: [%s] on line [%d] should be a symbol\\n\",",
   "\t         yytext, linecount);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",   
   "\"&\"[0-9a-zA-Z_.]+\";\"\t{",
   "\t yylval.data = makestr(yytext);",
   "#ifndef NOINTERFACE",
   "\t UpdateHighlight(yyleng);",
   "#endif",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",   
   "<WSPACE>[ \\t]+\t{",
   "\t yylval.data = makestr(yytext);",
   "#ifndef NOINTERFACE",
   "\t UpdateHighlight(yyleng);",
   "#endif",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",   
   "<WSPACE>[\\n]\t{",
   "\t linecount++;",
   "\t yylval.data = makestr(yytext);",
   "#ifndef NOINTERFACE",
   "\t UpdateHighlight(yyleng);",
   "#endif",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",   
   "\"<?\"[0-9a-zA-Z_.]+\">\"\t{",
   "#ifndef NOINTERFACE",
   "\t UpdateHighlight(yyleng);",
   "#endif",
   0
};

char
   *lexmid[] =
{
   "\t}",
   "",
   "[ \\t]+\t{",
   "#ifndef NOINTERFACE",
   "\t UpdateHighlight(yyleng);",
   "#endif",
   "\t}",
   "",   
   "[\\n]\t{",
   "\t linecount++;",
   "#ifndef NOINTERFACE",
   "\t UpdateHighlight(yyleng);",
   "#endif",
   "\t}",
   "",   
   0
};

char
   *lextail[] =
{
   "\"<\"[/]?[0-9a-zA-Z_.]+\">\"\t{",
   "\t BEGIN 0;",
   "\t BEGIN WSPACE;",
   "\t yylval.data = makestr(yytext);",
   "#ifndef NOINTERFACE",
   "\t UpdateHighlight(yyleng);",
   "#endif",
   "\t fprintf(stderr, \"Unrecognized tag [%s] on line [%d]\\n\",",
   "\t         yytext, linecount);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",
   ".\t{",
   "\t yylval.data = makestr(yytext);",
   "#ifndef NOINTERFACE",
   "\t UpdateHighlight(yyleng);",
   "#endif",
   "\t fprintf(stderr, \"Unrecognized character [%#5x] on line [%d]\\n\",",
   "\t         yytext[0], linecount);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",
   0
};
