/* Yacc specification for the intag specification language */
/* compiler.                                               */
/*                                                         */
/* Copyright 1990. The Ohio State University.              */

%{
#include "widgets.h"
#include "defs.h"
#include "types.h"

#include "liftab.h"
#include "status.h"
#include "xinterface.h"

#ifdef FLEX
extern char *yytext;
#else
extern char yytext[];
#endif
%}

%union
{
 int
    ival;
 char 
    *trans;
}

%token <ival>
IN
LINEFEED
NULLOP
MIXED
TAGS
DATA

%token <trans>
STAG
ETAG
TOP

%type <ival>
optnullclause
contenttype

%type <trans>
intagfile
multitagclause
optlevelinfo
tagclause
tagdef
tagdefplus
taginfo

%start intagfile

%%

intagfile	: tagdefplus	
		{
		}
		;

tagdefplus	: tagdefplus tagdef
		{
		}
		| tagdef
		{
		}
		;

tagdef		: taginfo optlevelinfo
		{
		}
		;

taginfo		: STAG contenttype optnullclause
		{
		   InstallTag($1, $2, $3, True, False);
		}
		| ETAG contenttype optnullclause
		{
		   InstallTag($1, $2, $3, False, True);
		}
		| STAG ETAG contenttype optnullclause
		{
		   InstallTag($1, $3, $4, True, True);
		}
		;

contenttype	: MIXED
		{
		   $$ = (int) Mixed;
		}
		| TAGS
		{
		   $$ = (int) Tags;
		}
		| DATA
		{
		   $$ = (int) Data;
		}
		| /* default for old specifications - backward compatibility */
		{
		   $$ = (int) Mixed;
		}
		;

optnullclause 	: NULLOP
		{
		   $$ = 1;
		}
		| /* no NULLOP */
		{
		   $$ = 0;
		}
		;

optlevelinfo	: IN multitagclause LINEFEED
		{
		}
		| LINEFEED /* empty - semantics = IN TOP */
		{
		   InstallLevel(TOPLEVEL);
		}
		;


multitagclause	: multitagclause tagclause
		{
		}
		| tagclause
		{
		}
		;


   
tagclause       : STAG
                {
		   InstallLevel($1);
                }
       		| ETAG
                {
		   InstallLevel($1);
		}
		| TOP
		{
		   InstallLevel($1);
		}
                ;
%%

void
yyerror(errorstr)

char
   *errorstr;

{
   XicaStatus(Statw, "Error: [%s] at or before [%s] on line %5d\n",
	      errorstr, yytext, ISFlinecount);
}
