/* Lex specification for the intag specification language */
/* compiler.                                              */
/*                                                        */
/* Copyright 1990. The Ohio State University.             */


%{
#include "icomp.h"

extern int ISFlinecount;
extern char *makestr();
%}

%START icafile
%%
^"$$$$\n"	{
	   BEGIN 0;
	   BEGIN icafile;
	}

<icafile>"#### Insert Tag Tool Rules ####\n"	{
   	   BEGIN 0;
	}

<icafile>.+	{
#ifdef DEBUG
	   fprintf(stderr, "STUFF [%s]\n", yytext); 
#endif
	}

<icafile>[\n]+	{
#ifdef DEBUG
	   fprintf(stderr, "STUFF [%s]\n", yytext); 
#endif
	}



":IN:" 	{
#ifdef DEBUG
	   fprintf(stderr, "[%s]\n", yytext); 
#endif
	   return(IN);
	}

":TOPLEVEL:"	{
#ifdef DEBUG
	   fprintf(stderr, "[%s]\n", yytext); 
#endif
	   yylval.trans = makestr(yytext);
	   return(TOP);
	}

":MIXED:"	{
#ifdef DEBUG
	   fprintf(stderr, "[%s]\n", yytext); 
#endif
	   return(MIXED);
	}

":TAGS:"	{
#ifdef DEBUG
	   fprintf(stderr, "[%s]\n", yytext); 
#endif
	   return(TAGS);
	}

":DATA:"	{
#ifdef DEBUG
	   fprintf(stderr, "[%s]\n", yytext); 
#endif
	   return(DATA);
	}

":NULL:"	{ 
#ifdef DEBUG
	   fprintf(stderr, "[%s]\n", yytext); 
#endif
	   return(NULLOP);
	}

\<[-a-zA-Z0-9@#$%&*=+|~!?\^_\.]+\>	{
#ifdef DEBUG
	   fprintf(stderr, "[%s]\n", yytext); 
#endif
	   yylval.trans = makestr(yytext);
	   return(STAG);
	}


\<\/[-a-zA-Z0-9@#$%&*=+|~!?\^_\.]+\>	{
#ifdef DEBUG
	   fprintf(stderr, "[%s]\n", yytext); 
#endif
	   yylval.trans = makestr(yytext);
	   return(ETAG);
	}

\n	{
	   ISFlinecount++;
#ifdef DEBUG
	   fprintf(stderr, "LINEFEED [%d]\n", ISFlinecount); 
#endif
	   return(LINEFEED);
	}

\t	{
#ifdef DEBUG
	   fprintf(stderr,"TAB\n"); 
#endif
	}

%%
