/*********HEADLEX**********/


String
   headlex[] =
{
   "/*   Lex description of uniform tag set for   */",
   "/*   the purpose of inserting missing tags.   */",
   "/*                                            */",
   "/* Copyright 1990. The Ohio State University. */",
   "/*                                            */",
   "",
   "%a 30000",
   "%e 10000",
   "%k 10000",
   "%n 10000",
   "%o 40000",
   "%p 20000",
   "",
   "%{",
   "#include <icatypes.h>",
   "#include \"y.tab.h\"",
   "",
   "extern char *makestr();",
   "extern int linecount;",
   "%}",
   "",
   "%%",
   0
};



/*********TAILLEX**********/
String
   taillex[] =
{
   "",
   "[0-9a-zA-Z,./?;:'\"\\[\\]{}!@#$%^&*()\\-_+=|\\\\`~]+\t{",
   "\t yylval.data = makestr(yytext);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",
   "[<>]\t{",
   "\t yylval.data = makestr(yytext);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",
   "\"<?\"[0-9a-zA-Z_\\.]+\">\"\t{",
   "\t yylval.data = makestr(yytext);",
   "\t return(ICA_PROC_IN);",
   "\t}",
   "",
   "[ \\t]+\t{",
   "\t yylval.data = makestr(yytext);",
   "\t return(ICA_PROC_IN);",
   "\t}",
   "",
   "\\n\t{",
   "\t yylval.data = makestr(yytext);",
   "\t linecount++;",
   "\t return(ICA_PROC_IN);",
   "\t}",
   "",
   "%%",
   0
};



/*********HEADYACC*********/

String
   headyacc[] =
{
   "/*  Yacc description of uniform tag set for   */",
   "/*  the purpose of inserting missing tags.    */",
   "/*                                            */",
   "/* Copyright 1990. The Ohio State University. */",
   "/*                                            */",
   "",
   "%{",
   "#include <stdio.h>",
   "#include <ctype.h>",
   "#include <icatypes.h>",
   "",
   "extern ConcatStruct",
   "\t*structconcat(),",
   "\t*structnew();",
   "extern void",
   "\tstructprint();",
   "extern char",
   "\t*yytext;",
   "%}",
   "",
   "%union",
   "{",
   " int ival;",
   " char *data;",
   " ConcatStruct *trans;",
   "}",
   "",
   "%token <data>",
   "ICA_Char_DATA",
   "ICA_PROC_IN",
   0
   };



/*********MIDYACC1*********/

String
   midyacc1[] =
{
   "",
   "%type <trans>",
   "file",
   "document",
   "textplus",
   "text",
   0
};



/*********MIDYACC2*********/

String
   midyacc2[] =
{
   "",
   "%start file",
   "",
   "%%",
   "",
   "file\t\t: documentplus",
   "\t\t{",
   "\t\t}",
   "\t\t;",
   "",
   "documentplus\t: documentplus document",
   "\t\t{",
   "\t\t}",
   "\t\t| document",
   "\t\t{",
   "\t\t}",
   "\t\t;",
   "",
   "document\t: TopleveltextortagsP",
   "\t\t{",
   "\t\t  $$ = structconcat($1, NULL);",
   "\t\t  structprint($$);",
   "\t\t}",
   "\t\t;\n",
   0
};


/*********TAILYACC*********/

String
   tailyacc[] =
{
   "Topleveltextortags\t: Topleveltags",
   "\t\t{",
   "\t\t  $$ = structconcat($1, NULL);",
   "\t\t}",
   "\t\t| textplus",
   "\t\t{",
   "\t\t  $$ = structconcat($1, NULL);",
   "\t\t}",
   "\t\t;\n",
   "textplus\t: text textplus",
   "\t\t{",
   "\t\t  $$ = structconcat($1, $2, NULL);",
   "\t\t}",
   "\t\t| text",
   "\t\t{",
   "\t\t  $$ = structconcat($1, NULL);",
   "\t\t}",
   "\t\t;\n",
   "text\t\t: ICA_Char_DATA",
   "\t\t{",
   "\t\t  $$ = structconcat(structnew($1), NULL);",
   "\t\t}",
   "\t\t| ICA_PROC_IN",
   "\t\t{",
   "\t\t  $$ = structconcat(structnew($1), NULL);",
   "\t\t}",
   "\t\t;\n",
   "%%",
   0
};

