/* CONTENTS
   Owner:       Copyright 1991 The Ohio State University,
                Integrated Chameleon Architecture
   Module:      $RCSfile: status.c,v $
   Purpose:     To feedback status information to the user.

   Programmer:  Conleth O'Connell
   Reviewer:    
   Revision:    $Revision: 1.4 $
   Date:        $Date: 92/05/29 15:33:15 $


   Functions Index:
   AVAIL   NAME DEPENDS ON INTERNALLY      EXTERNALLY
   -----   ----            ----------      ----------

*/

/* HISTORY
   $Log:	status.c,v $
 * Revision 1.4  92/05/29  15:33:15  boyd
 * Changes to improve resizing, consisting mostly of replacing Form widgets with
 * Group, Table, and Viewform.
 * 
 * 
 * Revision 1.3  92/03/16  13:53:50  ware
 * Make titles consistent.  Fix some consistency problems.
 * 
 * Revision 1.2  1992/01/28  22:36:55  cso
 * Restructured dependencies
 *
 * Revision 1.1  1991/11/27  16:03:40  cso
 * Initial revision
 *
 * Revision 1.1  1991/11/27  00:31:02  cso
 * Initial revision
 *
 * Revision 1.1  1991/11/20  00:01:32  cso
 * Initial revision
 *
*/

/* #INCLUDES */

#include "widgets.h"
#include "defs.h"

/* #DEFINES  */

/*  EXTERNS  */

/*  GLOBALS  */

Widget
   Statw;



/*
   FUNCTION: 		CreateStatus

   Synopsis: 
       Create the window for feeding back status info.

   Initial purpose:
       Same as above.

   Present purpose:
       Same as above.

   Creator:	Conleth O'Connell
   Reviewer:	

   Modifications:
       DATE     WHO      REASON

   Operating System issues:
       CALL		 PURPOSE

   System files modified:
       none

   Globals used:
       none

   Globals Modified:
       none

   Return value:	Widget

   Range:		none
*/

Widget CreateStatus( parent )
Widget parent;
{
   Widget statframe, statlabel;
      
   statframe = XtVaCreateManagedWidget( "statframe",
       groupWidgetClass, parent,
       XtNspacing,   0,
       XtNalignment, gaFill,
/*
       XtNstretch,   False,
*/
       XtNmargin,    8,
       NULL );

   statlabel = XtVaCreateManagedWidget( "statlabel",
       labelWidgetClass, statframe,
       XtNlabel,       "Status:",
       XtNborderWidth, 0,
       XtNmargin,      0,
       NULL );

   Statw = XtVaCreateManagedWidget( "Statw",
       statusWidgetClass, statframe,
       XtNalignment,        gaFill,
       XtNpreference,       False,
/*
       XtNprefHeight,       96,
       XtNminHeight,        20,
       XtNstretch,          False,
*/
       XtNmargin,           0,
       NULL );

   return(statframe);
}
