/*********HEADLEX*********/

String
   headlex[] =
{
   "/*   Lex description of nonuniform tag set.   */",
   "/*                                            */",
   "/* Copyright 1990. The Ohio State University. */",
   "/*                                            */",
   "",
   "%a 30000",
   "%e 10000",
   "%k 10000",
   "%n 10000",
   "%o 40000",
   "%p 20000",
   "",
   "%{",
   "#include <icatypes.h>",
   "#include \"y.tab.h\"",
   "",
   "extern int cntlinefeeds();",
   "extern int pop();",
   "extern void push();",
   "",
   "extern int linecount;",
   "%}",
   "",
   "",
   0
};


/*********MIDLEX*********/

String
   midlex[] =
{
   "%%",
   0
};


/*********TAILLEX*********/

String
   taillex[] =
{
   "",
   "[ \\t]+\t{",
   "\t yylval.data = makestr(yytext);",
   "\t return(ICA_WHITESPACE);",
   "\t}",
   "",
   "\\n\t{",
   "\t yylval.data = makestr(yytext);",
   "\t linecount++;",
   "\t return(ICA_WHITESPACE);",
   "\t}",
   "",
   ".\t{",
   "\t fprintf(stderr, \"Unmatched character [%s] in line %d.\\n\",",
   "\t\t yytext, linecount);",
   "\t yylval.data = makestr(yytext);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",
   "%%",
   0
};



/*********HEADYACC*********/

String
   headyacc[] =
{
   "/*  Yacc description of nonuniform tag set.   */",
   "/*                                            */",
   "/* Copyright 1990. The Ohio State University. */",
   "/*                                            */",
   "",
   "%{",
   "",
   "#include <stdio.h>",
   "#include <ctype.h>",
   "#include <icatypes.h>",
   "",
   "",
   "%}",
   "",
   "%union",
   "{",
   " int ival;",
   " char *data;",
   " ConcatStruct *trans;",
   "}",
   "",
   "%token <data>",
   "ICA_Char_DATA",
   "ICA_WHITESPACE",
   0
};


/*********MIDYACC1*********/

String
   midyacc1[] =
{
   "",
   "%type <trans>",
   "file",
   "document",
   "textortagsplus",
   "textortagsstar",
   "textortags",
   "text",
   "tags",
   "nonsegmenting",
   "segmenting",
   "",
   "%start file",
   "",
   "%%",
   "",
   "file\t\t: documentplus",
   "\t\t{",
   "\t\t}",
   "\t\t;",
   "",
   "documentplus\t: documentplus document",
   "\t\t{",
   "\t\t}",
   "\t\t| document",
   "\t\t{",
   "\t\t}",
   "\t\t;",
   "",
   0
};

/*********MIDYACC2*********/

String
   midyacc2[] =
{
   "textortagsplus\t: textortagsplus textortags",
   "\t\t{",
   "\t\t $$ = structconcat($1, $2, NULL);",
   "\t\t}",
   "\t\t| textortags",
   "\t\t{",
   "\t\t $$ = structconcat($1, NULL);",
   "\t\t}",
   "\t\t;",
   "",
   "textortagsstar\t: textortagsstar textortags",
   "\t\t{",
   "\t\t $$ = structconcat($1, $2, NULL);",
   "\t\t}",
   "\t\t|\t/* null */",
   "\t\t{",
   "\t\t $$ = structconcat(structnew(\"\"), NULL);",
   "\t\t}",
   "\t\t;",
   "",
   "textortags\t: text",
   "\t\t{",
   "\t\t $$ = structconcat($1, NULL);",
   "\t\t}",
   "\t\t| tags",
   "\t\t{",
   "\t\t $$ = structconcat($1, NULL);",
   "\t\t}",
   "\t\t;",
   "",
   "tags\t\t: nonsegmenting",
   "\t\t{",
   "\t\t $$ = structconcat($1, NULL);",
   "\t\t}",
   "\t\t| segmenting",
   "\t\t{",
   "\t\t $$ = structconcat($1, NULL);",
   "\t\t}",
   "\t\t;",
   "",
   0
};


/*********MIDYACC3*********/

String
   midyacc3[] =
{
   "text\t\t: ICA_Char_DATA",
   "\t\t{",
   "\t\t $$ = structconcat(structnew($1), NULL);",
   "\t\t}",
   "\t\t| ICA_WHITESPACE",
   "\t\t{",
   "\t\t $$ = structconcat(structnew($1), NULL);",
   "\t\t}",
   0
};


/*********TAILYACC*********/

String
   tailyacc[] =
{
   "",
   "%%",
   0
};
