%{
#include <stdio.h>

extern int
  amax,
  cmax,
  tmax;

extern int
  ambtab[],
  contab[],
  termidx[],
  termtab[];

extern void
   dump(),
   insert(),
   DumpConflicts();

extern int
   FindToken();
%}

%union
{
 int
    num;
 char 
    *str;
}


%token <num>
   COLON
   FORMFEED
   NUMBER
   ON
   REDUCE
   RR
   SR
   SNUMBER
   SHIFT
   STATE

%token <str>
   TOKEN

%start yout

%%

yout		: optprejunk states junk
		;

states		: states state
		| state
		;

state		: STATE NUMBER junk
		{
		   amax = $2;
		}
		| conflicts STATE NUMBER junk
		{
		   DumpConflicts();
		   tmax++;
		}
		;

conflicts	: conflicts conflict
		| conflict
		;

conflict	: SNUMBER COLON RR REDUCE NUMBER REDUCE NUMBER ON TOKEN
		{
		   int
		      token;

		   amax = $1;
		   if (ambtab[amax] == 0)
		   {
		      ambtab[amax] = tmax;
		   }
		   token = FindToken($9);   
		   if ((token == -1) && (strcmp("$end", $9) != 0)) 
		   {
		      fprintf(stderr, "Can't find token %s \n",$9);
		      return(1);
		   }
		   insert(token, $5, $7);
		   free($9);
		}
		;
		| SNUMBER COLON SR SHIFT NUMBER REDUCE NUMBER ON TOKEN
		{
		   int
		      token;

		   amax = $1;
		   if (ambtab[amax] == 0)
		   {
		      ambtab[amax] = tmax;
		   }
		   token = FindToken($9);
		   if ((token == -1) && (strcmp("$end", $9) != 0)) 
		   {
		      fprintf(stderr, "Can't find token %s \n", $9);
		      return(1);
		   }
		   insert(token, -1, $7);
		   free($9);
		}
		;

optprejunk	: junk FORMFEED
		| /* empty */
		;
    
junk		: junk TOKEN
		{
		   free($2);
		}
		| junk NUMBER
		| junk SR
		| junk RR
		| junk COLON
		| junk SHIFT
		| junk REDUCE
		| /* empty */
		;
%%

void
   yyerror(errorstr)

char
   *errorstr;

{
   extern char
      *yytext;

   fprintf(stderr, "[%s]\n", errorstr);
   fprintf(stderr, "amax   = [%d]\n", amax);
   fprintf(stderr, "yytext = [%s]\n", yytext);
}
