%{
#include "conflict.h"
extern char *makestr();
%}

#ifndef FLEX_SCANNER
%o 10000
#endif

%%
^state	{
#ifdef DEBUG
	   fprintf(stderr, "returning STATE\n");
#endif
	   return(STATE);
	}

":"	{
#ifdef DEBUG
	   fprintf(stderr, "returning COLON\n");
#endif
	   return(COLON);
	}

"reduce/reduce conflict"	{
#ifdef DEBUG
	   fprintf(stderr, "returning RR\n");
#endif
	   return(RR);
	}

"shift/reduce conflict"		{
#ifdef DEBUG
	   fprintf(stderr, "returning SR\n");
#endif
	   return(SR);
	}

"shift"	{
#ifdef DEBUG
	   fprintf(stderr, "returning SHIFT\n");
#endif
	   return(SHIFT);
	}

"reduce"|"red'n"	{
#ifdef DEBUG
	   fprintf(stderr, "returning REDUCE\n");
#endif
	   return(REDUCE);
	}

"on"	{
#ifdef DEBUG
	   fprintf(stderr, "returning ON\n");
#endif
	   return(ON);
	}

[0-9]+/":"	{
	   yylval.num = atoi(yytext);
#ifdef DEBUG
	   fprintf(stderr, "returning SNUMBER [%d]\n", yylval.num);
#endif
	   return(SNUMBER);
	}

[0-9]+	{
	   yylval.num = atoi(yytext);
#ifdef DEBUG
	   fprintf(stderr, "returning NUMBER [%d]\n", yylval.num);
#endif
	   return(NUMBER);
	}

[0-9a-zA-Z@#&~<>_=\`\';:\"\\\|\[\]\^\-\?\.\*\+\!\$\/\{\}\%]+	{
	   yylval.str = makestr(yytext);
#ifdef DEBUG
	   fprintf(stderr, "returning TOKEN [%s]\n", yylval.str);
#endif
	   return(TOKEN);
	}

[\t\n ,()]	{
	}

[\f]	{
#ifdef DEBUG
	   fprintf(stderr, "returning FORMFEED\n");
#endif
	   return(FORMFEED);
	}
%%
