#include <stdio.h>
   
#include "defs.h"
   
int
   ambtab[MAX],
   amax,
   contab[MAX],
   cmax,
   termidx[MAX],
   tindex,
   termtab[MAX],
   tmax,
   tmpmax[TMAX],
   maxterms;
char
   *terms[MAX],
   *malloc();



void
Initialize()

{
   char
      str[LMAX];
   FILE
      *defile;
   int
      i;
   
   amax     = 0;
   cmax     = 1;
   tmax     = 1;
   tindex   = 0;
   maxterms = 0;
   
   for (i = 0; i < MAX; i++)
   {
      ambtab[i]  = 0;
      contab[i]  = 0;
      termidx[i] = 0;
      termtab[i] = 0;
   }
   
   for (i = 0; i < TMAX; i++)
   {
      tmpmax[i] = 0;
   }
   
   defile = fopen("y.tab.h", "r");
   if (defile == NULL)
   {
      fprintf(stderr, "Could not open y.tab.h.\n");
      exit(1);
   }
#ifdef DEBUG
   fprintf(stderr, "Scanning defile\n");
#endif
   while (fscanf(defile, "%s", str) != EOF)
   {
#ifdef DEBUG
      fprintf(stderr, "scanned str [%s]\n", str);
#endif
      if ((strcmp(str, DFN1) == 0) || (strcmp(str, DFN2) == 0))
      {
	 if (fscanf(defile, "%s", str) != EOF)
	 {
	    terms[maxterms] = malloc((unsigned) strlen(str) + 1);
	    if (terms[maxterms] == NULL)
	    {
	       fprintf(stderr,
		       "Could not allocate space for terminal [%s]\n",
		       str);
	       exit(1);
	    }
	    strcpy(terms[maxterms], str);
#ifdef DEBUG
	    fprintf(stderr,
		    "terms[maxterms] = [%s]: maxterms = [%d]\n",
		    terms[maxterms], maxterms);
#endif
	    maxterms++;
	 }
      }
   }
   fclose(defile);
   return;
}



void
OutputTables()

{
   FILE
      *fptr;
   int
      i;
   
   fptr = fopen("yyetab", "w");
   if (fptr == NULL)
   {
      fprintf(stderr, "Could not open output file.\n");
      return;
   }
   /* write out the tables */
   fprintf(fptr, "short yyambtab[] = {");
   for (i = 0; i <= amax; i++)
   {
      if (i%10 == 0)
      {
	 fprintf(fptr, "\n");
      }
      fprintf(fptr, "%4d", ambtab[i]);
      if (i == amax)
      {
	 fprintf(fptr, "};\n\n");
      }
      else
      {
	 fprintf(fptr, ",");
      }
   }
   
   fprintf(fptr, "short yytermtab[] = {");
   for (i = 0; i < tmax; i++)
   {
      if (i%10 == 0)
      {
	 fprintf (fptr, "\n");
      }
      fprintf(fptr,"%4d", termtab[i]);
      if ((i + 1) == tmax)
      {
	 fprintf(fptr, "};\n\n");
      }
      else
      {
	 fprintf(fptr, ",");
      }
   }
   
   fprintf(fptr,"short yytermidx[] = {");
   for (i = 0; i < tmax; i++)
   {
      if (i%10 == 0)
      {
	 fprintf (fptr, "\n");
      }
      fprintf(fptr, "%4d",termidx[i]);
      if ((i + 1) == tmax)
      {
	 fprintf(fptr, "};\n\n");
      }
      else
      {
	 fprintf(fptr, ",");
      }
   }
   
   fprintf(fptr, "short yycontab[] = {");
   for (i = 0; i < cmax; i++)
   {
      if (i%10 == 0)
      {
	 fprintf(fptr, "\n");
      }
      fprintf(fptr, "%4d", contab[i]);
      if ((i + 1) == cmax)
      {
	 fprintf(fptr, "};\n\n");
      }
      else
      {
	 fprintf(fptr, ",");
      }
   }
   fclose(fptr);
   return;
}


int
main()

{
   extern FILE
      *yyin;
   
   Initialize();
   yyin = fopen("y.output", "r");
   if (yyin != NULL)
   {
      if (yyparse() != 0)
      {
	 fprintf(stderr, "Error in parsing y.output file\n");
      }
      else
      {
	 OutputTables();
      }
      fclose(yyin);
   }
   return(0);
}

int
yywrap()

{
   return(1);
}
