char
   *yacchead[] = 
{
   "%{",
   "#include <stdio.h>",
   "#include <ctype.h>",
   "#include <icatypes.h>",
   "%}",
   "",
   "%union",
   "{",
   " int   ival;",
   " char *data;",
   " ConcatStruct *trans;",
   "}",
   "",
   0
};


char
   *lexhead[] =
{
   "/*   Lex description of nonuniform tag set.   */",
   "/*                                            */",
   "/* Copyright 1990. The Ohio State University. */",
   "/*                                            */",
   "",
   "%a 30000",
   "%e 10000",
   "%k 10000",
   "%n 10000",
   "%o 40000",
   "%p 20000",
   "",
   "%{",
   "#include <icatypes.h>",
   "#include \"y.tab.h\"",
   "",
   "int linecount = 1;",
   "%}",
   "",
   "%START WSPACE",
   "",
   "%%",
   "[a-zA-Z0-9\\-_!@#$%^*()=+|\\\\~`'\",.;:\\[\\]{}?/]+\t{",
   "\t BEGIN 0;",
   "\t BEGIN WSPACE;",
   "\t yylval.data = makestr(yytext);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",
   "[<>&]\t{",
   "\t BEGIN 0;",
   "\t BEGIN WSPACE;",
   "\t yylval.data = makestr(yytext);",
   "\t fprintf(stderr, \"WARNING: [%s] on line [%d] should be a symbol\\n\",",
   "\t         yytext, linecount);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",
   "<WSPACE>[ \\t]+\t{",
   "\t yylval.data = makestr(yytext);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",   
   "<WSPACE>[\\n]\t{",
   "\t linecount++;",
   "\t yylval.data = makestr(yytext);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",   
   "[ \\t]+\t{",
   "\t}",
   "",   
   "[\\n]\t{",
   "\t linecount++;",
   "\t}",
   "",   
   0
};

char
   *lextail[] =
{
   "\"&\"[0-9a-zA-Z_.]+\";\"\t{",
   "\t BEGIN 0;",
   "\t BEGIN WSPACE;",
   "\t yylval.data = makestr(yytext);",
   "\t fprintf(stderr, \"Unrecognized entity [%s] on line [%d]\\n\",",
   "\t         yytext, linecount);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",
   "\"<\"[/]?[0-9a-zA-Z_.]+\">\"\t{",
   "\t BEGIN 0;",
   "\t BEGIN WSPACE;",
   "\t yylval.data = makestr(yytext);",
   "\t fprintf(stderr, \"Unrecognized tag [%s] on line [%d]\\n\",",
   "\t         yytext, linecount);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",
   ".\t{",
   "\t yylval.data = makestr(yytext);",
   "\t fprintf(stderr, \"Unrecognized character [%#5x] on line [%d]\\n\",",
   "\t         yytext[0], linecount);",
   "\t return(ICA_Char_DATA);",
   "\t}",
   "",
   0
};
