/*
  The symbol table structure.
 */
typedef struct SymbolTableType
{
   char   *symbol;     /* Name of a symbol in the grammar         */
   int    star;        /* Count of the use of this occurrence     */
   int    plus;        /* Count of the use of this occurrence     */
   int    optional;    /* Count of the use of this occurrence     */
   struct SymbolTableType *next;
} SymbolTable;

typedef struct TokenMappingType {
  char                    *token;
  char                    *text;
  struct TokenMappingType *next;
} TokenMapping;

typedef struct ProductionType
{
   char               *lhs;
   struct RhsListType *rhs;
   struct RhsListType *activerhs;
   int                 numrhs;
} Production;

typedef struct RhsListType
{
   struct RhsListType         *next;
   struct RhsListType         *prev;
   struct SymbolListType      *symbol;
   struct PermutationListType *perminstance;
   struct PermutationListType *activeperm;
} RhsList;

typedef struct SymbolListType
{
   struct SymbolListType *next;
   struct SymbolListType *prev;
   char                  *symbolstr;
   char                  *occurstr;
} SymbolList;

typedef struct PermutationListType
{
   struct PermutationListType *next;
   struct PermutationListType *prev;
   SymbolList                 *permsymbol;
} PermutationList;

