#include <stdio.h>
#include "types.h"

extern char *
   MakeUpper();
extern int
   Gmax;
extern Production
   Grammar[];



SymbolTable *
PutSymbol(tableroot, symbolstr)

SymbolTable
   *tableroot;
char
   *symbolstr;

{
   int
      newflag;
   SymbolTable
      *tmptab,
      *tptr;

   tmptab = (SymbolTable *) malloc((unsigned) sizeof(SymbolTable));
   if (tmptab == NULL)
   {
      fprintf(stderr, "PutSymbol: Could not allocate space\n");
      exit(1);
   }
   newflag = 1;
   tptr    = tableroot;
   if (tableroot != NULL)
   {
      if (strcmp(tableroot->symbol, symbolstr) == 0)
      {
	 newflag = 0;
	 tptr = tableroot;
      }
      else
      {
	 for (tptr = tableroot; tptr->next != NULL; tptr = tptr->next)
	 {
	    if (strcmp(tptr->next->symbol, symbolstr) == 0)
	    {
	       newflag = 0;
	       tptr = tptr->next;
	       break;
	    }
	 }
      }	 
   }
   if (newflag == 1)
   {
      tmptab->symbol   = symbolstr;
      tmptab->optional = 0;
      tmptab->star     = 0;
      tmptab->plus     = 0;
      tmptab->next     = NULL;
      
      if (tableroot == NULL)
      {
	 tableroot = tmptab;
      }
      else
      {
	 tptr->next = tmptab;
      }
   }
   else
   {
      free(tmptab);
      tmptab = tptr;
   }
   return(tmptab);
}




SymbolTable *
MakeSymbolTable(tableroot)

SymbolTable
   *tableroot;

{
   int
      i;
   RhsList
      *rptr;
   SymbolList
      *sptr;
   SymbolTable
      *tptr;
      
   tableroot = NULL;
   
   tptr = PutSymbol(tableroot, Grammar[0].lhs);
   if (tableroot == NULL)
   {
      tableroot = tptr;
   }
   
   for (i = 0; i < Gmax; i++)
   {
      for (rptr = Grammar[i].rhs; rptr != NULL; rptr = rptr->next)
      {
	 for (sptr = rptr->symbol; sptr != NULL; sptr = sptr->next)
	 {
	    if (sptr->symbolstr[0] != '<')
	    {
	       tptr = PutSymbol(tableroot, sptr->symbolstr);
	       if (tableroot == NULL)
	       {
		  tableroot = tptr;
	       }
	       
	       
	       switch (sptr->occurstr[0])
	       {
	       default:
		  break;
		  
	       case '*':
		  tptr->star++;
		  break;
		  
	       case '+':
		  tptr->plus++;
		  break;
		  
	       case '?':
		  tptr->optional++;
		  break;
	       }
	    }
	 }
      }
   }
   return(tableroot);
}




SymbolTable *
PutToken(tableroot, symbolstr)

SymbolTable
   *tableroot;
char
   *symbolstr;

{
   int
      newflag;
   SymbolTable
      *tmptab,
      *tptr;

   tmptab = (SymbolTable *) malloc((unsigned) sizeof(SymbolTable));
   if (tmptab == NULL)
   {
      fprintf(stderr, "PutToken: Could not allocate space\n");
      exit(1);
   }
   newflag = 1;
   tptr    = tableroot;
   if (tableroot != NULL)
   {
      if (strcmp(tableroot->symbol, symbolstr) == 0)
      {
	 newflag = 0;
	 tptr = tableroot;
      }
      else
      {
	 for (tptr = tableroot; tptr->next != NULL; tptr = tptr->next)
	 {
	    if (strcmp(tptr->next->symbol, symbolstr) == 0)
	    {
	       newflag = 0;
	       tptr = tptr->next;
	       break;
	    }
	 }
      }	 
   }
   if (newflag == 1)
   {
      tmptab->symbol   = symbolstr;
      tmptab->optional = 0;
      tmptab->star     = 0;
      tmptab->plus     = 0;
      tmptab->next     = NULL;
      
      if (tableroot == NULL)
      {
	 tableroot = tmptab;
      }
      else
      {
	 tptr->next = tmptab;
      }
   }
   else
   {
      free(tmptab);
      tmptab = tptr;
   }
   return(tmptab);
}




SymbolTable *
MakeTokenTable(tableroot)

SymbolTable
   *tableroot;

{
   int
      i;
   RhsList
      *rptr;
   SymbolList
      *sptr;
   SymbolTable
      *tptr;
      
   tableroot = NULL;
   for (i = 0; i < Gmax; i++)
   {
      for (rptr = Grammar[i].rhs; rptr != NULL; rptr = rptr->next)
      {
	 for (sptr = rptr->symbol; sptr != NULL; sptr = sptr->next)
	 {
	    if (sptr->symbolstr[0] == '<')
	    {
	       tptr = PutToken(tableroot, sptr->symbolstr);
	       if (tableroot == NULL)
	       {
		  tableroot = tptr;
	       }
	    }
	 }
      }
   }
   return(tableroot);
}




char *
CreateEmptyTag(tag)

char *
   tag;

{
   char
      *emstr,
      *uptag;
   int
      i;
   
   emstr = (char *) malloc((unsigned) (2 * strlen(tag)) + 16);
   if (emstr == NULL)
   {
      fprintf(stderr, "CreateEmptyTag: Unable to allocate memory\n");
      exit(1);
   }
   else
   {
      for (i = 0; i < Gmax; i++)
      {
	 if (strcmp(tag, Grammar[i].lhs) == 0)
	 {
	    if ((Grammar[i].rhs != NULL) && (Grammar[i].rhs->symbol != NULL))
	    {
	       if (*Grammar[i].rhs->symbol->symbolstr == '<')
	       {
		  uptag = MakeUpper(tag);
		  sprintf(emstr, "structnew(\"<%s></%s>\")", uptag, uptag);
		  free(uptag);
		  return(emstr);
	       }
	    }
	 }
      }
   }
   sprintf(emstr, "structnew(\"\")");
   return(emstr);
}




char *
GetMapping(tag, sptr1)

char
   *tag;
SymbolList
   *sptr1;

{
   char
      *str;
   int
      i;
   SymbolList
      *sptr;

   if (tag[0] == '<')
   {
      str = (char *) malloc((unsigned) (strlen(tag) + 32));
      if (str == NULL)
      {
	 fprintf(stderr, "GetMapping: Could not allocate [%d] bytes\n",
		 strlen(tag) + 32);
	 exit(1);
      }
      sprintf(str, "structnew(\"%s\\n\")", tag);
      return(str);
   }
   else
   {
      for (sptr = sptr1, i = 1;
	   ((sptr != NULL) &&
	    (strcmp(sptr->symbolstr, tag) != 0));
	   sptr = sptr->next, i++)
      {
      }
      if (sptr != NULL)
      {
	 str = (char *) malloc((unsigned) 16);
	 if (str == NULL)
	 {
	    fprintf(stderr, "GetMapping: Could not allocate [16] bytes\n");
	    exit(1);
	 }
	 sprintf(str, "$%d", i);
	 return(str);
      }
      else
      {
	 /*
	  * This symbol is not included in the permutation, so create
	  * an empty content tag for it if it is not a grouping symbol.
	  */
	 return(CreateEmptyTag(tag));
      }
   }
   /* Unnecessary return
    *  return(tag);
    */
}
