/* CONTENTS
   Owner:       Copyright 1990 The Ohio State University,
                Integrated Chameleon Architecture
   Module:      
   Purpose:     To load a user file which conforms to frank's grammer.
   Programmer:  Frank Adelstein Conleth O'Connell
   Reviewer:    
   Revision:    $Revision: 1.3 $
   Date:        $Date: 92/03/17 18:02:51 $
*/

/* HISTORY
    Revision 1.0   8/10/90   kalpak
    Wrote yacc pgm which initializes all datastructures
*/


%{
#include <stdio.h>
#include "types.h"

extern Production
   Grammar[];
extern int
   Gmax;
extern char
   *makestr();

#define NewType(type) ((type *) malloc((unsigned) sizeof(type)))
%}

%union
{
   struct
   {
      char
	 *str;
      char
	 *occur;
   } symbol;

   RhsList
      *rhsptr;
   PermutationList
      *permptr;
}

%token <symbol>
BEGIN_ACTION_ROUTINE
END_ACTION_ROUTINE
ENDTAG
MAPPING
OCCURRENCE_OPERATOR
OR
PROCIN
SEPARATOR
SEMICOLON
STARTTAG
SYMBOL
TOKENSEPARATOR

%type <symbol>
lhs
rhs_symbol
action_routine_symbol

%type <rhsptr>
rhs_list
mapping
rhs

%type <permptr>
ar_list
action_routine
action_routine_symbolSTAR



%start FrankSL

%%
FrankSL		: TOKENSEPARATOR tokenlineSTAR TOKENSEPARATOR productionPLUS
		{
		}	
		;

tokenlineSTAR	: tokenlineSTAR tokenline
		{
		}
		| /* empty */
		{
		}
		;

tokenline	: MAPPING MAPPING MAPPING
		{
		}
		;

productionPLUS	: productionPLUS production
		{
		}
		| production
		{
		}
		;

production	: lhs SEPARATOR rhs_list SEMICOLON
		{
		   int
		      i;
		   RhsList
		      *rl;
		   
		   Grammar[Gmax].lhs       = makestr($1.str);
		   Grammar[Gmax].rhs       = $3;
		   Grammar[Gmax].activerhs = $3;
		   for (i = 0, rl = Grammar[Gmax].rhs; rl != NULL; 
			i++, rl = rl->next)
		   {
		   }
		   Grammar[Gmax].numrhs    = i;
		   Gmax++;
		   free($1.str);
		}
		;

lhs		: SYMBOL
		{
		   $$.str   = $1.str;
		   $$.occur = "";
		}
		;

rhs_list	: mapping 
		{
		   $$ = $1;
		}
		| rhs_list OR mapping 
		{
		   RhsList
		      *rptr;
		   
                   rptr = $1;
		   if (rptr != NULL)
		   {
		      for ( ; rptr->next != NULL; rptr = rptr->next)
		      {
		      }
		      rptr->next = $3;
		      if ($3 != NULL)
		      {
			 $3->prev = rptr;
		      }
		      $$ = $1;
		   }
		   else 
		   {
		      fprintf(stderr,
			      "rhslist: $1->symbol is NULL\n");
		      exit(1);
		   }
		}
		;

mapping		: rhs ar_list 
		{
		   $1->perminstance = $2;
		   $1->activeperm   = $2;
		   $$               = $1;
		}
		;

rhs		: rhs_symbol
		{
		   RhsList
		      *rptr;
		   
		   rptr                    = NewType(RhsList);
		   rptr->next              = NULL;
		   rptr->prev              = NULL;
		   rptr->perminstance      = NULL;
		   rptr->symbol            = NewType(SymbolList);
		   rptr->symbol->prev      = NULL;
		   rptr->symbol->next      = NULL;
		   rptr->symbol->symbolstr = makestr($1.str);
		   rptr->symbol->occurstr  = makestr($1.occur);
		   $$                      = rptr;
		   free($1.str);
		   free($1.occur);
		}
		| rhs rhs_symbol 
		{
		   SymbolList
		      *sptr;
		   
		   sptr = $1->symbol;
		   if (sptr != NULL)
		   {
		      for ( ; sptr->next != NULL; sptr = sptr->next)
		      {
		      }
		      sptr->next            = NewType(SymbolList);
		      sptr->next->prev      = sptr;
		      sptr->next->next      = NULL;
		      sptr->next->symbolstr = makestr($2.str);
		      sptr->next->occurstr  = makestr($2.occur);
		      $$                    = $1;
		   }
		   else 
		   {
		      fprintf(stderr,
			      "rhs: $1->symbol is NULL\n");
		      exit(1);
		   }
		   free($2.str);
		   free($2.occur);
		}
		;

rhs_symbol	: STARTTAG 
		{
		   $$.str   = $1.str;
		   $$.occur = "";
		}
                | ENDTAG 
		{
		   $$.str   = $1.str;
		   $$.occur = "";
		}
		| SYMBOL OCCURRENCE_OPERATOR 
		{
		   $$.str   = $1.str;
		   $$.occur = $2.occur;
		}
		| SYMBOL 
		{
		   $$.str   = $1.str;
		   $$.occur = "";
		}
		;

ar_list		: action_routine
		{
		   $$ = $1;
		}
		| ar_list action_routine 
		{
		   PermutationList
		      *pptr;
		   
		   if ($1 != NULL)
		   {
		      for (pptr = $1; pptr->next != NULL;
			   pptr = pptr->next)
		      {
		      }
		      pptr->next = $2;
		      if ($2 != NULL)
		      {
			 $2->prev = pptr;
		      }
		      $$ = $1;
		   }
		}
		;

action_routine	: BEGIN_ACTION_ROUTINE action_routine_symbolSTAR END_ACTION_ROUTINE 
		{
		   $$ = $2;
		}
		;

action_routine_symbolSTAR	: /* NULL */
		{
		   PermutationList
		      *pptr;
		   
		   pptr             = NewType(PermutationList);
		   pptr->next       = NULL;
		   pptr->prev       = NULL;
		   pptr->permsymbol = NULL;
		   $$               = pptr;
		}
		| action_routine_symbolSTAR action_routine_symbol
		{
		   SymbolList
		      *sptr;
		   
		   sptr = $1->permsymbol;
		   if (sptr != NULL)
		   {
		      for ( ; sptr->next != NULL; sptr = sptr->next)
		      {
		      }
		      sptr->next            = NewType(SymbolList);
		      sptr->next->prev      = sptr;
		      sptr->next->next      = NULL;
		      sptr->next->symbolstr = makestr($2.str);
		      sptr->next->occurstr  = "";
		   }
		   else 
		   {
		      sptr            = NewType(SymbolList);
		      sptr->prev      = NULL;
		      sptr->next      = NULL;
		      sptr->symbolstr = makestr($2.str);
		      sptr->occurstr  = "";
                      $1->permsymbol  = sptr;
		   }
		   $$ = $1;
		   free($2.str);
		}
		;

action_routine_symbol		: STARTTAG 
		{
		   $$.str   = $1.str;
		   $$.occur = "";
		}
			| ENDTAG 
		{     
		   $$.str   = $1.str;
		   $$.occur = "";
		}
	        	| SYMBOL 
	        {
		   $$.str   = $1.str;
		   $$.occur = "";
		}
	        	| PROCIN
	        {
		   $$.str   = $1.str;
		   $$.occur = "";
		}
	        ;
%%
