%{
#include "types.h"
#include "uptg.h"

extern char
   *makestr();

int
   linecount;
%}

%START TAGINFO
%%

<TAGINFO>^"$$$$"		{
   BEGIN 0;
   return(TOKENSEPARATOR);
}

<TAGINFO>[ 0-9a-zA-Z!@#$%^&*()_+|\-=\\\[\]{};'`:"~,\.\/<>?]+	{
   return(MAPPING);
}

^"$$$$"			{
   BEGIN 0;
   BEGIN TAGINFO;
   return(TOKENSEPARATOR);
}

"<"[a-zA-Z0-9_\.]+">"	{
   yylval.symbol.str = makestr(yytext);
   return(STARTTAG);
}

"</"[a-zA-Z0-9_\.]+">"	{
   yylval.symbol.str = makestr(yytext);
   return(ENDTAG);
}

"<?"[a-zA-Z0-9_\.]+">"	{
   yylval.symbol.str = makestr(yytext);
   return(PROCIN);
}

[a-zA-Z0-9_\.]+	{
   yylval.symbol.str = makestr(yytext);
   return(SYMBOL);
}

"*"			{
   yylval.symbol.occur = makestr(yytext);
   return(OCCURRENCE_OPERATOR);
}

"+"			{
   yylval.symbol.occur = makestr(yytext);
   return(OCCURRENCE_OPERATOR);
}

"?"			{
   yylval.symbol.occur = makestr(yytext);
   return(OCCURRENCE_OPERATOR);
}

":"			{
   return(SEPARATOR);
}

"("			{
   return(BEGIN_ACTION_ROUTINE);
}

")"			{
   return(END_ACTION_ROUTINE);
}

";"			{
   return(SEMICOLON);
}

"|"			{
   return(OR);
}

[\n]			{
   linecount++;
}

[ \t]			{
}

.			{
#ifdef DEBUG
   fprintf(stderr, "Unknown char [%s]\n", yytext);
#endif
}

%%
