#include <stdio.h>
#include <errno.h>

#include "types.h"

extern UpInterface
   Upitype;



void
Output(fptr, str)

FILE
   *fptr;
char
   *str[];

{
   int
      i;
   
   for (i = 0; str[i] != 0; i++)
   {
      fprintf(fptr, "%s\n", str[i]);
   }
}



void
MakeTranslator(target)

char
   *target;

{
   char
      *icaroot,
      *makestring;
   int
      len;
   
   /* figure out if ICAROOT is defined */
   /* otherwise, just assume the current directory.  */
   
   icaroot = (char *) getenv("ICAROOT");
   if (icaroot == NULL)
   {
      icaroot = ".";
   }
   len = strlen(target);
   makestring = (char *) malloc((unsigned) (len + 128));
   if (makestring == NULL)
   {
      fprintf(stderr, "MakeTranslator: unable to allocate [%d] bytes\n",
	      len + 128);
      exit(1);
   }
   switch (Upitype)
   {
   default:
      break;
      
   case With:
#ifdef AUTOSHIFT
      sprintf(makestring,
	      "make -f %s/lib/Makefile.up 'TARGET=%s' 'INTFLAGS=-DAUTOSHIFT'&",
	      icaroot, target);
#else
      sprintf(makestring,
	      "make -f %s/lib/Makefile.up 'TARGET=%s' 'INTFLAGS='&",
	      icaroot, target);
#endif
      break;
      
   case Without:
      sprintf(makestring,
      "make -f %s/lib/Makefile.up 'TARGET=%s' 'INTFLAGS=-DNOINTERFACE'&",
	      icaroot, target);
      break;
   }
   
#ifdef DEBUG
   fprintf(stderr, "Making [%s]\n", makestring);
#endif
   errno = 0;
   if (system(makestring) < 0)
   {
      perror("System call to Make up translator failed");
   }
   free(makestring);
   return;
}




/*
   FUNCTION: 		MakeUpper

   Synopsis: 
       Make a string into the uppercase equivalent.

   Initial purpose:
       Same as above.

   Present purpose:
       Same as above.

   Creator:	Conleth O'Connell
   Reviewer:	

   Modifications:
       DATE       WHO    REASON

   Globals used:
       none

   Globals Modified:
       none

   Return value:	String

   Range:		An upper case version of the input string
*/

char *
MakeUpper(str)

char *
   str;  /* The string being transformed */

{
   char *
      tmp; /* A temporary copy */
   int
      i;   /* Loop counter to examine at each character */
   
   /*
    * Make a copy of the string
    * For each character, consider if it should be changed
    */
   tmp = (char *) makestr(str);
   for (i = 0; i < strlen(tmp); i++)
   {
      /*
       * If the character is a lower case alphabetic character
       * Make it upper case
       */
      if (islower(tmp[i]))
      {
	 tmp[i] = toupper(tmp[i]);
      }
   }
   return(tmp);
}
