#include <stdio.h>
#include <varargs.h>

#ifdef FLEX
extern char *yytext;
#else
extern char yytext[];
#endif

extern FILE
   *yyin;
extern int
   linecount;

int
main(argc, argv)

int
   argc;
char
   **argv;

{
   if (argc > 1)
   {
      if ((yyin = fopen(argv[1], "r")) == NULL)
      {
	 (void) fprintf(stderr, "Bad input file name: %s \n", argv[1]);
	 exit (1);
      }
   }
  
   linecount = 1;
  
   if (yyparse() == 0) 
   {
      (void) fprintf(stderr, "Translated with no problems\n");
   }
   else 
   {
      (void) fprintf(stderr, "Translation incomplete\n");
   }
   return(0);
}


void
yyerror(errorstr)

char
   *errorstr;

{
  (void) fprintf(stderr, "Error [%s] at or before [%s] on line [%5d]\n",
		 errorstr, yytext, linecount);
  return;
}

