/* CONTENTS
   Owner:       Copyright 1991 The Ohio State University,
                Integrated Chameleon Architecture
   Module:      $RCSfile: intagdriver.c,v $
   Purpose:     ITT (insert tag tool) driver, main program

   Programmer:  Julie Ann Barnes
   Reviewer:    
   Revision:    $Revision: 1.5 $
   Date:        $Date: 92/05/21 21:57:38 $

NOTE:
   AVAIL can be:
	HIDDEN for internal use only
	EXPORT for internal and external use

   Functions Index:
   AVAIL   NAME DEPENDS ON INTERNALLY      EXTERNALLY
   -----   ----            ----------      ----------

*/

/* HISTORY
   $Log:	intagdriver.c,v $
 * Revision 1.5  92/05/21  21:57:38  ware
 * 
 * Allow files to be passed on command line instead of only stdin.  Clean
 * up several error messages.
 * 
 * Revision 1.4  92/03/17  18:04:25  ware
 * Use ICA.defs
 * 
 * Revision 1.3  1992/03/10  17:17:21  cso
 * Added the -DFLEX cflag for yytext
 *
 * Revision 1.2  1991/11/06  19:56:44  cso
 * typed and returned in main()
 *
 * Revision 1.1.1.2  1991/10/04  19:41:36  jbm
 * Integrated Chameleon Architecture
 * Ohio State University
 * Alpha 2.0 release
 *
*/

/* #INCLUDES */
#include <stdio.h>
#include <ctype.h>

/* GLOBALS */
int linecount;

#ifdef FLEX
extern char *yytext;
#else
extern char yytext[];
#endif
extern FILE *yyin;


/*
   FUNCTION: 		

   Synopsis: ITT

   Initial purpose:
       Same as above.

   Present purpose:
       Same as above.

   Creator:	Julie Ann Barnes
   Reviewer:	

   Modifications:
       DATE     WHO      REASON

   Operating System issues:
       CALL		 PURPOSE

   System files modified:
       none

   Globals used:
       none

   Globals Modified:
       none

   Return value:	void

   Range:		none
*/

int
main(argc, argv)

int
   argc;
char
   *argv[];

{
   if (argc > 1)
   {
      if ((yyin = fopen(argv[1], "r")) == NULL)
      {
	 (void) fprintf(stderr, "Bad input file name: %s \n", argv[1]);
	 exit (1);
      }
   }
   fprintf(stderr, "Inserting tags...\n");
   linecount = 1;
   if (yyparse() == 0)
   {
      fprintf(stderr, "Tag insertion process completed.\n");
   }
   else
   {
      fprintf(stderr, "Tag insertion process failed.\n");
   }
   return(0);
}



/*
  FUNCTION: 		
  
  Synopsis: ITT
  
  Initial purpose:
  Same as above.
  
  Present purpose:
  Same as above.
  
  Creator:	Julie Ann Barnes
  Reviewer:	
  
  Modifications:
  DATE     WHO      REASON
  
  Operating System issues:
  CALL		 PURPOSE
  
  System files modified:
  none
  
  Globals used:
  none
  
  Globals Modified:
  none
  
  Return value:	void
  
  Range:		none
  */

void
yyerror(errorstr)

char
   *errorstr;

{
  fprintf(stderr, "Error [%s] at or before [%s] on line [%5d]\n",
	  errorstr, yytext, linecount);
  return;
}

int
yywrap()

{
   fprintf(stderr, "Number of input lines read = %6d\n", linecount);
   return(1);
}
