#ifndef _FileDlg_h
#define _FileDlg_h

#include <X11/Shell.h>

/* Resources

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
New:
 dataFont            Font               XFontStruct     XtDefaultFont
 labelFont           Font               XFontStruct     XtDefaultFont
 btnFont             Font               XFontStruct     XtDefaultFont
 btnCursor           Cursor             Cursor          hand2
 spacing             Thickness          Int             8
 lines               Lines              Int             8
 path                Path               String          NULL
 spec                Spec               String          "*"
 name                Name               String          NULL
 dlgTitle            Title              String          NULL
 prompt              Prompt             String          "Open:"
 button              Button             String          "Open"
 mustMatch           MustMatch          Boolean         True
 mustExist           MustExist          Boolean         True
 willRead            WillRead           Boolean         True
 willWrite           willWrite          Boolean         False
 willExecute         willExecute        Boolean         False
 confirm             Confirm            Boolean         False
 sorted              Sorted             Boolean         True
 dirsFirst           DirsFirst          Boolean         True
 filesFirst          FilesFirst         Boolean         False
 showDots            ShowDots           Boolean         True
 fileCheck           FileCheck          Callback        NULL
 selectProc          SelectProc         Callback        NULL
 cancelProc          CancelProc         Callback        NULL


Parent/Child Widgets
 Name		     Class		Description
 ----		     -----		--------------------
 dlgform             form               hold all other children
 dlgname             Label              holds title (above)
 iprompt             Label              prompt for input: "Open:"
 input               TextFld            input field for file name
 list                List               list of directory & file names
 vp                  Viewport           parent of list, for scrolling
 openbtn             Command            accept a selected file or directory
 resetbtn            Command            return to original path spec
 cancelbtn           Command            exit dialog without selecting
 wait                Wait               displays clockface while searching
*/

#define  XtNdataFont     "dataFont"
#define  XtNlabelFont    "labelFont"
#define  XtNbtnFont      "btnFont"
#define  XtNbtnCursor    "btnCursor"
#define  XtNspacing      "spacing"
#define  XtNlines        "lines"
#define  XtNpath         "path"
#define  XtNspec         "spec"
#define  XtNfileName     "fileName"
#define  XtNdlgTitle     "dlgTitle"
#define  XtNprompt       "prompt"
#define  XtNbutton       "button"
#define  XtNmustMatch    "mustMatch"
#define  XtNmustExist    "mustExist"
#define  XtNwillRead     "willRead"
#define  XtNwillWrite    "willWrite"
#define  XtNwillExecute  "willExecute"
#define  XtNconfirm      "confirm"
#define  XtNsorted       "sorted"
#define  XtNdirsFirst    "dirsFirst"
#define  XtNfilesFirst   "filesFirst"
#define  XtNshowDots     "showDots"
#define  XtNfileCheck    "fileCheck"
#define  XtNselectProc   "selectProc"
#define  XtNcancelProc   "cancelProc"

#define  XtCSpacing      "Spacing"
#define  XtCLines        "Lines"
#define  XtCPath         "Path"
#define  XtCSpec         "Spec"
#define  XtCName         "Name"
#define  XtCPrompt       "Prompt"
#define  XtCButton       "Button"
#define  XtCMustMatch    "MustMatch"
#define  XtCMustExist    "MustExist"
#define  XtCWillRead     "WillRead"
#define  XtCWillWrite    "WillWrite"
#define  XtCWillExecute  "WillExecute"
#define  XtCConfirm      "Confirm"
#define  XtCSorted       "Sorted"
#define  XtCDirsFirst    "DirsFirst"
#define  XtCFilesFirst   "FilesFirst"
#define  XtCShowDots     "ShowDots"


typedef struct _FileDlgClassRec	*FileDlgWidgetClass;
typedef struct _FileDlgRec	*FileDlgWidget;

extern WidgetClass fileDlgWidgetClass;

typedef struct  {
    String  name;      /* input value */
    Boolean exists;    /* input value */
    Boolean ok;        /* return value */
} FILECHK_PRM, *pFILECHK_PRM;

extern FileDlgWidget SetupFileDialog( /* parent */ );
extern void DoFileDialog( /* filedlg  */ );

#endif /* _FileDlg_h */


