#ifndef _FileDlgP_h
#define _FileDlgP_h

#include "FileDlg.h"
#include <X11/ShellP.h>
#include <X11/VendorP.h>

typedef struct {int empty;} FileDlgClassPart;

typedef struct _FileDlgClassRec {
    CoreClassPart	    core_class;
    CompositeClassPart      composite_class;
    ShellClassPart          shell_class;
    WMShellClassPart        wm_shell_class;
    VendorShellClassPart    vendor_shell_class;
    TransientShellClassPart transient_shell_class;
/*    
    OverrideShellClassPart  override_shell_class;
*/
    FileDlgClassPart        filedlg_class;
} FileDlgClassRec;

extern FileDlgClassRec fileDlgClassRec;

typedef struct {
    String  path;     /* common path for list names */
    String  spec;     /* common spec for list file names */
    int     num;      /* number of names in list */
    int     nd, nf;   /* numbers of directories and files */
    int     len;      /* length of longest */
    String  *name;    /* list of names */
    Boolean *access;  /* corresponding list of access flags */
} DF_LIST, *pDF_LIST;

typedef struct _FileDlgPart {
    /* resources */
    XFontStruct   *dataFont;      /* fonts passed to children */
    XFontStruct   *labelFont;
    XFontStruct   *btnFont;
    Cursor         btnCursor;
    int            spacing;       /* default spacing for form */
    int            lines;         /* number of lines to display in lists */
    String         path;          /* initial/current path */
    String         spec;          /* initial/current file spec */
    String         name;          /* initial/current file name (no path) */
    String         title;         /* Title of dialog box */
    String         prompt;        /* text of fprompt */
    String         button;        /* label of selectbtn */
    Boolean        mustMatch;     /* file part of pathSpec must match? */
    Boolean        mustExist;     /* a selected file must exist? */
    Boolean        willRead;      /* read access required? */
    Boolean        willWrite;     /* write access required? */
    Boolean        willExecute;   /* execute access required? */
    Boolean        confirm;       /* confirm overwrite of existing file? */
    Boolean        sorted;        /* show sorted lists? */
    Boolean        dirsFirst;     /* sort directories to front? */
    Boolean        filesFirst;    /* sort files to front? */
    Boolean        showDots;      /* show .* files with * */
    XtCallbackList fileCheck;     /* called to check selected file name */
    XtCallbackList selectProc;    /* called with selected file name */
    XtCallbackList cancelProc;    /* called if dialog is canceled */

    /* private */
    String    defaultPath;        /* default path */
    String    defaultSpec;        /* default file spec (to enforce) */
    String    defaultName;        /* default file name */
    DF_LIST   dflist;             /* dir and file name list */

    Widget    dlgbox, textbox, listbox, btnbox;
    Widget    dlgname;
    Widget    iprompt, input;
    Widget    listlbl;
    Widget    vp, list;
    Widget    openbtn, resetbtn, cancelbtn;
    Widget    wait;
} FileDlgPart;

typedef struct _FileDlgRec {
    CorePart		core;
    CompositePart	composite;
    ShellPart 	        shell;
    WMShellPart         wm;
    VendorShellPart     vendor;
    TransientShellPart  transient;
/*
    OverrideShellPart   override;	
*/
    FileDlgPart		filedlg;
} FileDlgRec;

#endif /* _FileDlgP_h */
