#ifndef _GroupP_h
#define _GroupP_h

#include <X11/ConstrainP.h>
#include "Group.h"

#define XtRAlignment "Alignment"
#define XtRPlacement "Placement"

#define XtInheritLayout ((void (*)())_XtInherit)

typedef struct {
    void (*layout)(/* GroupWidget */);
} GroupClassPart;

typedef struct _GroupClassRec {
    CoreClassPart       core_class;
    CompositeClassPart  composite_class;
    ConstraintClassPart constraint_class;
    GroupClassPart      group_class;
} GroupClassRec;

extern GroupClassRec groupClassRec;

typedef struct _GroupPart {
    /* resources */
    Dimension     spacing;          /* default distance between children  */
    XtOrientation orientation;      /* vertical or horizontal             */
    GroupPlace    place;            /* placement for unstretched children */
    /* private */
    int         no_refigure;        /* no re-layout while > 0             */
    Boolean     needs_relayout;     /* next time no_refigure == 0         */
    Dimension   pw, ph;             /* preferred width/height             */
    Dimension   mw, mh;             /* minimum width/height               */
    Boolean     reordered;          /* insertAfter/fromSibling have chgd  */
} GroupPart;

typedef struct _GroupRec {
    CorePart            core;
    CompositePart       composite;
    ConstraintPart      constraint;
    GroupPart           group;
} GroupRec;

typedef struct _GroupConstraintsPart {
    GroupAlign  align;          /* alignment for this child widget        */
    Dimension   margin;         /* desired margin                         */
    Boolean     stretch;        /* TRUE if child may absorb extra spacing */
    Dimension   mw, mh;         /* minimum width & height                 */
    Boolean     preference;     /* query child for preferred geometry     */
    Dimension   pw, ph;         /* preferred width, height                */
    Boolean     after;          /* insert new child after?                */
    Widget      from;           /* sibling to insert from                 */
} GroupConstraintsPart;

typedef struct _GroupConstraintsRec {
    GroupConstraintsPart        group;
}
GroupConstraintsRec, *GroupConstraints;

#endif /* _GroupP_h */
