#ifndef _MsgBox_h
#define _MsgBox_h

#include <X11/Shell.h>

/* Resources

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
New:
 labelFont           Font               XFontStruct     XtDefaultFont
 btnFont             Font               XFontStruct     XtDefaultFont
 btnCursor           Cursor             Cursor          hand2
 message             Message            String          NULL
 response            Response           Boolean         (returned)
 defaultResponse     DefaultResponse    Boolean         True
 done                Done               Boolean         (returned)

Parent/Child Widgets
 Name		     Class		Description
 ----		     -----		--------------------
 msggrp              Group              holds all other children
 msglbl              Label              holds title (above)
 btngrp              Group              holds buttons
 okbtn               Command            exit dialog
 yesbtn              Command            exit dialog with result "True"
 nobtn               Command            exit dialog with result "False"
 cancelbtn           Command            exit dialog without selecting
*/

#define  XtNlabelFont       "labelFont"
#define  XtNbtnFont         "btnFont"
#define  XtNbtnCursor       "btnCursor"
#define  XtNmessage         "message"
#define  XtNresponse        "response"
#define  XtNdefaultResponse "defaultResponse"
#define  XtNdone            "done"

#define  XtCMessage         "Message"
#define  XtCResponse        "Response"
#define  XtCDefaultResponse "DefaultResponse"
#define  XtCDone            "Done"


typedef struct _MsgBoxClassRec	*MsgBoxWidgetClass;
typedef struct _MsgBoxRec	*MsgBoxWidget;

extern WidgetClass msgBoxWidgetClass;

extern void OkMessage( /* Widget parent, String message */ );
extern Boolean OkCancelMessage( /* Widget parent, String message */ );
extern Boolean YesNoMessage( /* Widget parent, String message,
                                Boolean default */ );
extern Boolean YesNoCancelMessage( /* Widget parent, String message,
                                   Boolean default, Boolean *response */ );

#endif /* _MsgBox_h */


