#ifndef _MsgBoxP_h
#define _MsgBoxP_h

#include "MsgBox.h"
#include <X11/ShellP.h>
#include <X11/VendorP.h>

typedef struct {int empty;} MsgBoxClassPart;

typedef struct _MsgBoxClassRec {
    CoreClassPart	    core_class;
    CompositeClassPart      composite_class;
    ShellClassPart          shell_class;
    WMShellClassPart        wm_shell_class;
    VendorShellClassPart    vendor_shell_class;
    TransientShellClassPart transient_shell_class;
/*
    OverrideShellClassPart  override_shell_class;
*/
    MsgBoxClassPart         msgbox_class;
} MsgBoxClassRec;

extern MsgBoxClassRec msgBoxClassRec;

typedef struct _MsgBoxPart {
    /* resources */
    XFontStruct   *labelFont;
    XFontStruct   *btnFont;
    Cursor         btnCursor;
    String         message;       /* text of message */
    Boolean        response;      /* set if done */
    Boolean        defaultResponse;
    Boolean        done;          /* true if not cancelled */

    /* private */
    Widget    msggrp, btngrp;
    Widget    msglbl;
    Widget    okbtn, yesbtn, nobtn, cancelbtn;
} MsgBoxPart;

typedef struct _MsgBoxRec {
    CorePart		core;
    CompositePart	composite;
    ShellPart 	        shell;
    WMShellPart         wm;
    VendorShellPart     vendor;
    TransientShellPart  transient;
/*
    OverrideShellPart   override;
*/
    MsgBoxPart		msgbox;
} MsgBoxRec;

#endif /* _MsgBoxP_h */
