#ifndef _SensListP_h
#define _SensListP_h

/***********************************************************************
 *
 * SensList Widget Private Data
 *
 ***********************************************************************/

#include <X11/Xaw/SimpleP.h>
#include "SensList.h"

#define NO_HIGHLIGHT            XAW_LIST_NONE
#define OUT_OF_RANGE            -1
#define OKAY                     0

/* New fields for the SensList widget class record */

typedef struct {int foo;} SensListClassPart;

/* Full class record declaration */
typedef struct _SensListClassRec {
    CoreClassPart	core_class;
    SimpleClassPart	simple_class;
    SensListClassPart	list_class;
} SensListClassRec;

extern SensListClassRec sensListClassRec;

/* New fields for the SensList widget record */
typedef struct {
    /* resources */
    Pixel	foreground;
    Dimension	internal_width,
        	internal_height,
                column_space,
                row_space;
    int         default_cols;
    Boolean     force_cols,
                paste,
                vertical_cols;
    int         longest;
    int         nitems;		/* number of items in the list. */
    XFontStruct	*font;
    String *    list;
    Boolean *   eligible;
    XtCallbackList  callback;
    XtCallbackList  acceptProc;

    /* private state */

    int         is_highlighted,	/* set to the item currently highlighted. */
                highlight,	/*set to the item that should be highlighted.*/
                col_width,	/* width of each column. */
                row_height,	/* height of each row. */
                nrows,		/* number of rows in the list. */
                ncols;		/* number of columns in the list. */
    GC		normgc,		/* a couple o' GC's. */
                revgc,
                graygc;		/* used when inactive. */

} SensListPart;


/****************************************************************
 *
 * Full instance record declaration
 *
 ****************************************************************/

typedef struct _SensListRec {
    CorePart	        core;
    SimplePart	        simple;
    SensListPart	list;
} SensListRec;

#endif
