/*
 * Copyright 1991 The Ohio State University,
 *                Integrated Chameleon Architecture
 */

/*
  $Log:	icatypes.h,v $
 * Revision 1.1  92/03/18  14:06:55  ware
 * Initial revision
 * 
 * Revision 1.5  1992/03/10  03:57:00  cso
 * Added external definitions of the regexp and string libraries
 *
 * Revision 1.4  1992/02/21  23:21:00  cso
 * Using icatypes.h; tied regexp routines strongly into GUIs
 *
 * Revision 1.3  1992/01/28  18:51:13  cso
 * Starting to strengthen the ties to librex
 *
 * Revision 1.2  1991/10/09  21:10:42  cso
 * Created the data structure for tools doing structconcat()'s.
 * Eventually, all of the generated code will using it, but for now just
 * the generated retaggers will be using structconcat(), then intaggers,
 * etc.
 *
 * Revision 1.1.1.1  1991/10/04  19:34:25  jbm
 * Integrated Chameleon Architecture
 * Ohio State University
 * Alpha 2.0 release
 *
 * Revision 1.1  1991/10/04  19:34:24  jbm
 * Initial revision
 *
 */

typedef struct ConcatStructType
{
   char
      *string;
   struct ConcatStructType
      *next,
      *tail;
} ConcatStruct;

typedef enum CompStrReturnType
{
   STRING_MATCH          = 1,
   STRING_MATCH_RECOPIED = 2,
   STRING_NO_MATCH       = 3,
   REX_SYNTAX_ERROR      = 4,
   STRING_OTHER_ERROR    = 5
} CompStrReturn;

typedef enum ValidateRexReturnType
{
   BadRepetitionContent =  1,
   BadStartingChar      =  2,
   BlankFound           =  3,
   EmptyParens          =  4,
   EndingBackslash      =  5,
   IllegalOpenBrace     =  6,
   IllegalPercent       =  7,
   MissingCloseBracket  =  8,
   MissingCloseParen    =  9,
   MissingCloseQuote    = 10,
   MissingOpenBrace     = 11,
   MissingOpenParen     = 12,
   NonportableRange     = 13,
   Valid                = 14,
   WhereCloseBrace      = 15
} ValidateRexReturn;

extern char
   *concat(),
   *makeendtag(),
   *makestarttag(),
   *makestr(),
   *strgen();
extern CompStrReturn
   compare_string();
extern ConcatStruct
   *structconcat(),
   *structnew();
extern void
   structprint();
extern ValidateRexReturn
   is_valid_rex();
